/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/annotatedLanguage/common/csharpTokenization",["require","exports"],function(e,t){t.language2={displayName:"C#",name:"cs",defaultToken:"",lineComment:"// ",blockCommentStart:"/*",blockCommentEnd:"*/",wordDefinition:/(-?\d*\.\d\w*)|([^\`\~\!\#\$\%\^\&\*\(\)\-\=\+\[\{\]\}\\\|\;\:\'\"\,\.\<\>\/\?\s]+)/g,autoClosingPairs:[['"','"'],["'","'"],["{","}"],["[","]"],["(",")"]],brackets:[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}],editorOptions:{tabSize:4,insertSpaces:!0},keywords:["extern","alias","using","bool","decimal","sbyte","byte","short","ushort","int","uint","long","ulong","char","float","double","object","dynamic","string","assembly","module","is","as","ref","out","this","base","new","typeof","void","checked","unchecked","default","delegate","var","const","if","else","switch","case","while","do","for","foreach","in","break","continue","goto","return","throw","try","catch","finally","lock","yield","from","let","where","join","on","equals","into","orderby","ascending","descending","select","group","by","namespace","partial","class","field","event","method","param","property","public","protected","internal","private","abstract","sealed","static","struct","readonly","volatile","virtual","override","params","get","set","add","remove","operator","true","false","implicit","explicit","interface","enum","null","async","await"],namespaceFollows:["namespace","using"],parenFollows:["if","for","while","switch","foreach","using","catch"],operators:["=","??","||","&&","|","^","&","==","!=","<=",">=","<<","+","-","*","/","%","!","~","++","--","+=","-=","*=","/=","%=","&=","|=","^=","<<=",">>=",">>","=>"],symbols:/[=><!~?:&|+\-*\/\^%]+/,escapes:/\\(?:[abfnrtv\\"']|x[0-9A-Fa-f]{1,4}|u[0-9A-Fa-f]{4}|U[0-9A-Fa-f]{8})/,tokenizer:{root:[[/[a-zA-Z_]\w*/,{cases:{"@namespaceFollows":{token:"keyword.$0",next:"@namespace"},"@keywords":{token:"keyword.$0",next:"@qualified"},"@default":{token:"identifier",next:"@qualified"}}}],{include:"@whitespace"},[/}/,{cases:{"$S2==interpolatedstring":{token:"string.quote",bracket:"@close",next:"@pop"},"@default":"@brackets"}}],[/[{}()\[\]]/,"@brackets"],[/[<>](?!@symbols)/,"@brackets"],[/@symbols/,{cases:{"@operators":"operator","@default":""}}],[/@"/,{token:"string.quote",bracket:"@open",next:"@litstring"}],[/\$"/,{token:"string.quote",bracket:"@open",next:"@interpolatedstring"}],[/\d*\.\d+([eE][\-+]?\d+)?[fFdD]?/,"number.float"],[/0[xX][0-9a-fA-F]+/,"number.hex"],[/\d+/,"number"],[/[;,.]/,"delimiter"],[/"([^"\\]|\\.)*$/,"string.invalid"],[/"/,{token:"string.quote",bracket:"@open",next:"@string"}],[/'[^\\']'/,"string"],[/(')(@escapes)(')/,["string","string.escape","string"]],[/'/,"string.invalid"]],qualified:[[/[a-zA-Z_][\w]*/,{cases:{"@keywords":"keyword.$0","@default":"identifier"}}],[/\./,"delimiter"],["","","@pop"]],namespace:[{include:"@whitespace"},[/[A-Z]\w*/,"namespace"],[/[\.=]/,"delimiter"],["","","@pop"]],comment:[[/[^\/*]+/,"comment"],["\\*/","comment","@pop"],[/[\/*]/,"comment"]],string:[[/[^\\"]+/,"string"],[/@escapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],litstring:[[/[^"]+/,"string"],[/""/,"string.escape"],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],interpolatedstring:[[/[^\\"{]+/,"string"],[/@escapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/{{/,"string.escape"],[/}}/,"string.escape"],[/{/,{token:"string.quote",bracket:"@open",next:"root.interpolatedstring"}],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],whitespace:[[/^[ \t\v\f]*#\w.*$/,"namespace.cpp"],[/[ \t\v\f\r\n]+/,""],[/\/\*/,"comment","@comment"],[/\/\/.*$/,"comment"]]}}}),define("vs/languages/annotatedLanguage/common/references",["require","exports"],function(e,t){function n(e,t){var n=t.trange;return{resourceUrl:e.getResourceUrl(t.tref),range:n,preview:{text:t.preview,range:{startLineNumber:1,endLineNumber:1,startColumn:n.startColumn,endColumn:n.endColumn}}}}var r=function(){function e(e,t){this.entries=t,this.path=e}return e.prototype.getReferences=function(){return this.entries},e}();t.References=r,t.createReference=n}),define("vs/editor/common/core/position",["require","exports"],function(e,t){var n=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(e){return!!e&&this.lineNumber===e.lineNumber&&this.column===e.column},e.prototype.isBefore=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<e.column},e.prototype.isBeforeOrEqual=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<=e.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.create=function(t,n){return new e(t,n)},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e.asEmptyRange=function(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}},e.startPosition=function(e){return{lineNumber:e.startLineNumber,column:e.startColumn}},e.endPosition=function(e){return{lineNumber:e.endLineNumber,column:e.endColumn}},e}();t.Position=n}),define("vs/editor/common/core/range",["require","exports","vs/editor/common/core/position"],function(e,t,n){var r=function(){function e(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.prototype.getEndPosition=function(){return new n.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new n.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,n){return new e(this.startLineNumber,this.startColumn,t,n)},e.prototype.setStartPosition=function(t,n){return new e(t,n,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e.create=function(t,n,r,o){return new e(t,n,r,o)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},e.containsPosition=function(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:t.lineNumber===e.endLineNumber&&t.column>e.endColumn?!1:!0},e.containsRange=function(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn?!1:!0},e.areIntersectingOrTouching=function(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn?!1:!0},e.intersectRanges=function(t,n){var r=t.startLineNumber,o=t.startColumn,i=t.endLineNumber,s=t.endColumn,a=n.startLineNumber,u=n.startColumn,c=n.endLineNumber,l=n.endColumn;return a>r?(r=a,o=u):r===a&&(o=Math.max(o,u)),i>c?(i=c,s=l):i===c&&(s=Math.min(s,l)),r>i?null:r===i&&o>s?null:new e(r,o,i,s)},e.plusRange=function(t,n){var r,o,i,s;return n.startLineNumber<t.startLineNumber?(r=n.startLineNumber,o=n.startColumn):n.startLineNumber===t.startLineNumber?(r=n.startLineNumber,o=Math.min(n.startColumn,t.startColumn)):(r=t.startLineNumber,o=t.startColumn),n.endLineNumber>t.endLineNumber?(i=n.endLineNumber,s=n.endColumn):n.endLineNumber===t.endLineNumber?(i=n.endLineNumber,s=Math.max(n.endColumn,t.endColumn)):(i=t.endLineNumber,s=t.endColumn),new e(r,o,i,s)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.compareRangesUsingStarts=function(e,t){return e.startLineNumber===t.startLineNumber?e.startColumn===t.startColumn?e.endLineNumber===t.endLineNumber?e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber:e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e.hashCode=function(e){return 17*e.startLineNumber+23*e.startColumn+29*e.endLineNumber+37*e.endColumn},e.collapseToStart=function(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}},e}();t.Range=r}),define("vs/languages/annotatedLanguage/common/annotations",["require","exports","vs/base/common/winjs.base","./references","vs/base/common/paths","vs/editor/common/core/range"],function(e,t,n,r,o,i){var s=function(){function e(e,t){this.codeLensSymbols={type:!0,method:!0,property:!0},this.entries=t,this.resourceURL=e;var n=e.getPath().split("/",2);this.assembly=n[0],this.sourceName=n[1]}return e.prototype.getEntryAtOffset=function(e){for(var t=0;t<this.entries.length;t++){var n=this.entries[t];if(i.Range.containsPosition(n.range,e))return n}return null},e.prototype.findSymbolDecl=function(e){for(var t=0;t<this.entries.length;t++){var n=this.entries[t];if(n.symbolId===e&&"decl"===n.refType)return n}return null},e.prototype.findDeclaration=function(e,t){var r=this.getEntryAtOffset(t);if(!r)return null;if("decl"!==r.refType){if(r.declAssembly&&r.declAssembly!==this.assembly&&!r.declFile)return n.TPromise.as({resourceUrl:e.getResourceUrl(o.join(r.declAssembly,r.symbolId)),range:{startLineNumber:1,endLineNumber:1,startColumn:1,endColumn:1}});if(r.declAssembly&&r.declFile){var i=e.getResourceUrl(o.join(r.declAssembly,r.declFile));if(!i.equals(this.resourceURL))return e.getAnnotations(i,!0).then(function(e){return e.getDeclarationReference(r.symbolId)})}}return n.TPromise.as(this.getDeclarationReference(r.symbolId))},e.prototype.findOccurences=function(e,t){var r=this.getEntryAtOffset(t);return r?n.TPromise.as(this.entries.filter(function(e){return e.symbolId===r.symbolId}).map(function(e){return{kind:"write"===e.refType||"decl"===e.refType?"write":null,range:e.range}})):n.TPromise.as([])},e.prototype.findReferences=function(e,t,o){var i=this,s=this.getEntryAtOffset(o);return s?s.declAssembly?e.getReferences(s,!0).then(function(t){return t.getReferences().map(function(t){return r.createReference(e,t)})}):n.TPromise.as(this.entries.filter(function(e){return e.symbolId===s.symbolId}).map(function(e){var n=e.range,r={startLineNumber:n.startLineNumber,endLineNumber:n.endLineNumber,startColumn:1,endColumn:t.getLineMaxColumn(n.endLineNumber)};return{resourceUrl:i.resourceURL,range:n,preview:{text:t.getValueInRange(r),range:{startLineNumber:1,endLineNumber:1,startColumn:n.startColumn,endColumn:n.endColumn}}}})):null},e.prototype.getOutline=function(){var e=this;return this.entries.filter(function(e){return"decl"===e.refType&&"local"!==e.symbolType&&"param"!==e.symbolType}).map(function(t){return{label:t.label,type:e.getIconType(t),range:t.range}})},e.prototype.computeInfo=function(e){var t=this.getEntryAtOffset(e);if(t&&t.hover){var r=[];return r.push({className:"type",text:t.hover}),n.TPromise.as({range:t.range,htmlContent:r,className:"typeInfo al"})}},e.prototype.findCodeLensSymbols=function(){var e=this;return this.entries.filter(function(t){return"decl"===t.refType&&e.codeLensSymbols[t.symbolType]}).map(function(e){return{id:e.symbolId,range:e.range}})},e.prototype.getIconType=function(e){switch(e.symbolType){case"type":return"class";case"local":return"variable";case"param":return"variable";case"property":return"property";case"event":return"property";case"field":return"property";case"method":return"function"}return null},e.prototype.getDeclarationReference=function(e){var t=this.findSymbolDecl(e);if(t){var n=t.range;return{resourceUrl:this.resourceURL,range:n,preview:{text:t.preview,range:{startLineNumber:1,endLineNumber:1,startColumn:n.startColumn,endColumn:n.endColumn}}}}return null},e}();t.Annotations=s}),define("vs/platform/workspace/common/workspace",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IWorkspaceContextService=n.createDecorator("contextService")});var __decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/annotatedLanguage/common/annotatedResourceService",["require","exports","vs/base/common/network","vs/base/common/winjs.base","./annotations","./references","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/platform/instantiation/common/descriptors","vs/platform/workspace/common/workspace"],function(e,t,n,r,o,i,s,a,u,c){var l=function(){function e(e,t){this.contextServiceRoot="inmemory://model/",this.contextService=e,this.instantiationService=t,this.referencesStore={},this.annotationsStore={},this.annotationRequestServicePromise=null}return e.prototype.getAnnotationRequestService=function(){if(!this.annotationRequestServicePromise){var e=this.contextService.getOptions().annotationRequestService;if(e){var t=u.AsyncDescriptor.create(e.moduleName,e.ctorName);this.annotationRequestServicePromise=this.instantiationService.createInstance(t).then(function(e){return e},function(e){return r.TPromise.wrapError("Unable to instanciate "+t.moduleName+" / "+t.ctorName+": "+e)})}else this.annotationRequestServicePromise=r.TPromise.wrapError("annotationRequestService is not specified in the context options.")}return this.annotationRequestServicePromise},e.prototype.getAnnotations=function(e,t){var n=this.getPath(e),r=this.annotationsStore[n];return!r&&t&&(r=this.getAnnotationRequestService().then(function(t){return t.getAnnotations(n).then(function(t){var n=new o.Annotations(e,t);return n},function(t){return s.onUnexpectedError(t),new o.Annotations(e,[])})},function(t){return s.onUnexpectedError(t),new o.Annotations(e,[])}),this.annotationsStore[n]=r),r},e.prototype.getReferences=function(e,t){var n=e.symbolId,r=this.referencesStore[n];return!r&&t&&(r=this.getAnnotationRequestService().then(function(t){return t.getReferences(e.declAssembly,n).then(function(e){return new i.References(n,e)},function(e){return s.onUnexpectedError(e),new i.References(n,[])})},function(e){return s.onUnexpectedError(e),new i.References(n,[])}),this.referencesStore[n]=r),r},e.prototype.getResourceUrl=function(e){return new n.URL(this.contextServiceRoot+e)},e.prototype.getPath=function(e){return e.toString().substring(this.contextServiceRoot.length)},e=__decorate([__param(0,c.IWorkspaceContextService),__param(1,a.IInstantiationService)],e)}();t.AnnotatedResourceService=l});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/annotatedLanguage/common/annotatedLanguage",["require","exports","vs/base/common/winjs.base","./csharpTokenization","vs/editor/common/modes/supports","./annotatedResourceService","vs/editor/common/modes/monarch/monarch","vs/editor/common/modes/monarch/monarchCompile"],function(e,t,n,r,o,i,s,a){function u(e){var t={};for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);return t}var c=u(r.language2),l=function(e){function t(t,n,r){var s=this;e.call(this,t,n,r,a.compile(c)),this.modelService=t.modelService,this.suggestSupport=null,this.inplaceReplaceSupport=null,this.extraInfoSupport=this,this.referenceSupport=new o.ReferenceSupport(this,{tokens:["identifier.cs"],findReferences:function(e,t){return s.findReferences(e,t)}}),this.outlineSupport=this,this.declarationSupport=new o.DeclarationSupport(this,{tokens:["identifier.cs"],findDeclaration:function(e,t){return s.findDeclaration(e,t)}}),this.codeLensSupport=this,this.annotatedResourceService=t.instantiationService.createInstance(i.AnnotatedResourceService)}return __extends(t,e),t.prototype.computeInfo=function(e,t){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.computeInfo(t):null})},t.prototype.findOccurrences=function(e,t){var n=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findOccurences(n.annotatedResourceService,t):null})},t.prototype.findReferences=function(e,t){var n=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(r){if(r){var o=n.modelService.getModel(e);return r.findReferences(n.annotatedResourceService,o,t)}return null})},t.prototype.findDeclaration=function(e,t){var n=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findDeclaration(n.annotatedResourceService,t):null})},t.prototype.getOutline=function(e){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.getOutline():null})},t.prototype.enableCodeLens=function(){return!0},t.prototype.findCodeLensSymbols=function(e){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findCodeLensSymbols():null})},t.prototype.findCodeLensReferences=function(e,t){var r=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(o){return o?n.Promise.join(t.map(function(t){var n=r.modelService.getModel(e);return o.findReferences(r.annotatedResourceService,n,t.position)})).then(function(e){return{references:e,languageModeStateId:1}}):null})},t}(s.MonarchMode);t.ALMode=l});