/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/css/common/services/cssLanguageService",["require","exports","vs/base/common/winjs.base","vs/editor/common/services/resourceService"],function(e,t,n,r){var o=function(e){function t(){var t=this;e.call(this,function(e,n){t._valueCallback=e,t._errorCallback=n})}return __extends(t,e),t.prototype.resolve=function(e){return this._valueCallback(e),this},t.prototype.reject=function(e){return this._errorCallback(e),this},t}(n.TPromise),i=function(){function e(e,t,n){var o=this;this._cssModeId=n,this.resourceService=e,this.entries={},this.callOnDispose=[],this.createParser=t,this.updateResources(),this.callOnDispose.push(this.resourceService.addListener_(r.ResourceEvents.ADDED,function(e){return o.onResourceAdded(e)})),this.callOnDispose.push(this.resourceService.addListener_(r.ResourceEvents.REMOVED,function(e){return o.onResourceRemoved(e)})),this.callOnDispose.push(this.resourceService.addListener_(r.ResourceEvents.CHANGED,function(e){return o.onResourceChange(e)}))}return e.prototype.dispose=function(){for(;this.callOnDispose.length>0;)this.callOnDispose.pop()();clearTimeout(this.onChangeHandle),this.onChangeHandle=null,this.entries=null},e.prototype.onResourceAdded=function(e){this._isMyMirrorModel(e.addedElement)&&this._scheduleRefreshLanguageService()},e.prototype.onResourceRemoved=function(e){var t=e.url.toString();this.entries.hasOwnProperty(t)&&delete this.entries[t]},e.prototype.onResourceChange=function(e){this._isMyModel(e.url)&&this._scheduleRefreshLanguageService()},e.prototype._scheduleRefreshLanguageService=function(){var e=this;this.activeDelay||(this.activeDelay=new o),this.onChangeHandle&&clearTimeout(this.onChangeHandle),this.onChangeHandle=setTimeout(function(){e.updateResources(),e.activeDelay.resolve(null),e.activeDelay=null,e.onChangeHandle=null},50)},e.prototype.join=function(){return this.activeDelay||n.Promise.as(null)},e.prototype._isMyMirrorModel=function(e){return e.getMode().getId()===this._cssModeId},e.prototype._isMyModel=function(e){return this._isMyMirrorModel(this.resourceService.get(e))},e.prototype.updateResources=function(){var e=this,t=((new Date).getTime(),0);this.resourceService.all().filter(function(t){return e._isMyMirrorModel(t)}).forEach(function(n){var r=n.getAssociatedResource().toString(),o=e.entries[r],i="undefined"!=typeof o;i&&o.version===n.getVersionId()||(i||(o={node:null,version:-1},e.entries[r]=o),o.node=e.createParser().parseStylesheet(n),o.node.setName(r),o.version=n.getVersionId(),t+=1)})},e.prototype.getStylesheet=function(e){return this.entries.hasOwnProperty(e.toString())?this.entries[e.toString()].node:null},e}();t.CSSLanguageService=i});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/css/common/parser/cssNodes",["require","exports","vs/base/common/types"],function(e,t,n){function r(e,t){var n=null;return!e||t<e.offset||t>e.offset+e.length?null:(e.accept(function(e){return-1===e.offset&&-1===e.length?!0:e.offset<=t&&e.offset+e.length>=t?(n?e.length<=n.length&&(n=e):n=e,!0):!1}),n)}function o(e,t){for(var n=r(e,t),o=[];n;)o.unshift(n),n=n.parent;return o}function i(e){var t=e.findParent(s.Declaration);return t&&t.getValue()&&t.getValue().encloses(e)?t:null}!function(e){e[e.Undefined=0]="Undefined",e[e.Identifier=1]="Identifier",e[e.Stylesheet=2]="Stylesheet",e[e.Ruleset=3]="Ruleset",e[e.Selector=4]="Selector",e[e.SimpleSelector=5]="SimpleSelector",e[e.SelectorInterpolation=6]="SelectorInterpolation",e[e.SelectorCombinator=7]="SelectorCombinator",e[e.SelectorCombinatorParent=8]="SelectorCombinatorParent",e[e.SelectorCombinatorSibling=9]="SelectorCombinatorSibling",e[e.SelectorCombinatorAllSiblings=10]="SelectorCombinatorAllSiblings",e[e.Page=11]="Page",e[e.PageBoxMarginBox=12]="PageBoxMarginBox",e[e.ClassSelector=13]="ClassSelector",e[e.IdentifierSelector=14]="IdentifierSelector",e[e.ElementNameSelector=15]="ElementNameSelector",e[e.PseudoSelector=16]="PseudoSelector",e[e.AttributeSelector=17]="AttributeSelector",e[e.Declaration=18]="Declaration",e[e.Declarations=19]="Declarations",e[e.Property=20]="Property",e[e.Expression=21]="Expression",e[e.BinaryExpression=22]="BinaryExpression",e[e.Term=23]="Term",e[e.Operator=24]="Operator",e[e.Value=25]="Value",e[e.StringLiteral=26]="StringLiteral",e[e.URILiteral=27]="URILiteral",e[e.EscapedValue=28]="EscapedValue",e[e.Function=29]="Function",e[e.NumericValue=30]="NumericValue",e[e.HexColorValue=31]="HexColorValue",e[e.MixinDeclaration=32]="MixinDeclaration",e[e.MixinReference=33]="MixinReference",e[e.VariableName=34]="VariableName",e[e.VariableDeclaration=35]="VariableDeclaration",e[e.Prio=36]="Prio",e[e.Interpolation=37]="Interpolation",e[e.NestedProperties=38]="NestedProperties",e[e.ExtendsReference=39]="ExtendsReference",e[e.SelectorPlaceholder=40]="SelectorPlaceholder",e[e.Debug=41]="Debug",e[e.If=42]="If",e[e.Else=43]="Else",e[e.For=44]="For",e[e.Each=45]="Each",e[e.While=46]="While",e[e.MixinContent=47]="MixinContent",e[e.Media=48]="Media",e[e.Keyframe=49]="Keyframe",e[e.FontFace=50]="FontFace",e[e.Import=51]="Import",e[e.Namespace=52]="Namespace",e[e.Invocation=53]="Invocation",e[e.FunctionDeclaration=54]="FunctionDeclaration",e[e.ReturnStatement=55]="ReturnStatement",e[e.MediaQuery=56]="MediaQuery",e[e.FunctionParameter=57]="FunctionParameter",e[e.FunctionArgument=58]="FunctionArgument",e[e.KeyframeSelector=59]="KeyframeSelector",e[e.MSViewPort=60]="MSViewPort",e[e.Document=61]="Document"}(t.NodeType||(t.NodeType={}));var s=t.NodeType;!function(e){e[e.Mixin=0]="Mixin",e[e.Rule=1]="Rule",e[e.Variable=2]="Variable",e[e.Function=3]="Function",e[e.Keyframe=4]="Keyframe",e[e.Unknown=5]="Unknown"}(t.ReferenceType||(t.ReferenceType={}));t.ReferenceType;t.getNodeAtOffset=r,t.getNodePath=o,t.getParentDeclaration=i;var a=function(){function e(e,t,n){void 0===e&&(e=-1),void 0===t&&(t=-1),this.parent=null,this.offset=e,this.length=t,n&&(this.nodeType=n)}return Object.defineProperty(e.prototype,"type",{get:function(){return this.nodeType||s.Undefined},set:function(e){this.nodeType=e},enumerable:!0,configurable:!0}),e.prototype.getTextProvider=function(){for(var e=this;e&&!e.textProvider;)e=e.parent;return e?e.textProvider:function(){return"unknown"}},e.prototype.getText=function(){return this.getTextProvider()(this.offset,this.length)},e.prototype.matches=function(e){return this.length===e.length&&this.getTextProvider()(this.offset,this.length)===e},e.prototype.startsWith=function(e){return this.length>=e.length&&this.getTextProvider()(this.offset,e.length)===e},e.prototype.endsWith=function(e){return this.length>=e.length&&this.getTextProvider()(this.offset+this.length-e.length,e.length)===e},e.prototype.accept=function(e){n.isFunction(e)||(e=e.visitNode.bind(e)),e(this)&&this.children&&this.children.forEach(function(t){t.accept(e)})},e.prototype.adoptChild=function(e,t){if(void 0===t&&(t=-1),e.parent&&e.parent.children){var n=e.parent.children.indexOf(e);n>=0&&e.parent.children.splice(n,1)}e.parent=this;var r=this.children;return r||(r=this.children=[]),-1!==t?r.splice(n,0,e):r.push(e),e},e.prototype.attachTo=function(e,t){return void 0===t&&(t=-1),e&&e.adoptChild(this,t),this},e.prototype.collectIssues=function(e){this.issues&&e.push.apply(e,this.issues)},e.prototype.addIssue=function(e){this.issues||(this.issues=[]),this.issues.push(e)},e.prototype.hasIssue=function(e){return this.issues&&this.issues.some(function(t){return t.getRule()===e})},e.prototype.isErroneous=function(){return this.issues&&this.issues.length>0},e.prototype.setNode=function(e,t,n){return void 0===n&&(n=-1),t?(t.attachTo(this,n),this[e]=t,!0):!1},e.prototype.addChild=function(e){return e?(this.children||(this.children=[]),e.attachTo(this),this.updateOffsetAndLength(e),!0):!1},e.prototype.updateOffsetAndLength=function(e){(e.offset<this.offset||-1===this.offset)&&(this.offset=e.offset),(e.offset+e.length>this.offset+this.length||-1===this.length)&&(this.length=e.offset+e.length-this.offset)},e.prototype.hasChildren=function(){return this.children&&this.children.length>0},e.prototype.getChildren=function(){return this.children?this.children.slice(0):[]},e.prototype.getChild=function(e){return this.children&&e<this.children.length?this.children[e]:null},e.prototype.addChildren=function(e){var t=this;e.forEach(function(e){return t.addChild(e)})},e.prototype.findFirstChildBeforeOffset=function(e){if(this.children)for(var t=null,n=this.children.length-1;n>=0;n--)if(t=this.children[n],t.offset<=e)return t;return null},e.prototype.findChildAtOffset=function(e,t){var n=this.findFirstChildBeforeOffset(e);return n&&n.offset+n.length>=e?t?n.findChildAtOffset(e,!0)||n:n:null},e.prototype.encloses=function(e){return this.offset<=e.offset&&this.offset+this.length>=e.offset+e.length},e.prototype.getParent=function(){for(var e=this.parent;e instanceof u;)e=e.parent;return e},e.prototype.findParent=function(e){for(var t=this;t&&t.type!==e;)t=t.parent;return t},e.prototype.setData=function(e,t){this.options||(this.options={}),this.options[e]=t},e.prototype.getData=function(e){return this.options&&this.options.hasOwnProperty(e)?this.options[e]:null},e}();t.Node=a;var u=function(e){function t(t,n){void 0===n&&(n=-1),e.call(this,-1,-1),this.attachTo(t,n),this.offset=-1,this.length=-1}return __extends(t,e),t}(a);t.Nodelist=u;var c=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Identifier},enumerable:!0,configurable:!0}),t.prototype.containsInterpolation=function(){return this.hasChildren()},t}(a);t.Identifier=c;var l=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Stylesheet},enumerable:!0,configurable:!0}),t.prototype.setName=function(e){this.name=e},t}(a);t.Stylesheet=l;var p=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Declarations},enumerable:!0,configurable:!0}),t}(a);t.Declarations=p;var h=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),t.prototype.getDeclarations=function(){return this.declarations},t.prototype.setDeclarations=function(e){return this.setNode("declarations",e)},t}(a);t.BodyDeclaration=h;var d=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Ruleset},enumerable:!0,configurable:!0}),t.prototype.getSelectors=function(){return this.selectors||(this.selectors=new u(this)),this.selectors},t.prototype.isNested=function(){return this.parent&&null!==this.parent.findParent(s.Ruleset)},t}(h);t.RuleSet=d;var f=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Selector},enumerable:!0,configurable:!0}),t}(a);t.Selector=f;var m=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.SimpleSelector},enumerable:!0,configurable:!0}),t}(a);t.SimpleSelector=m;var g=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Declaration},enumerable:!0,configurable:!0}),t.prototype.setProperty=function(e){return this.setNode("property",e)},t.prototype.getProperty=function(){return this.property},t.prototype.getFullPropertyName=function(){var e=this.property?this.property.getName():"unknown";if(this.parent instanceof p&&this.parent.getParent()instanceof I){var n=this.parent.getParent().getParent();if(n instanceof t)return n.getFullPropertyName()+e}return e},t.prototype.getNonPrefixedPropertyName=function(){var e=this.getFullPropertyName();if(e&&"-"===e.charAt(0)){var t=e.indexOf("-",1);if(-1!==t)return e.substring(t+1)}return e},t.prototype.setValue=function(e){return this.setNode("value",e)},t.prototype.getValue=function(){return this.value},t.prototype.setNestedProperties=function(e){return this.setNode("nestedProprties",e)},t.prototype.getNestedProperties=function(){return this.nestedProprties},t}(a);t.Declaration=g;var v=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Property},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.getText()},t}(a);t.Property=v;var y=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Invocation},enumerable:!0,configurable:!0}),t.prototype.getArguments=function(){return this.arguments||(this.arguments=new u(this)),this.arguments},t}(a);t.Invocation=y;var _=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Function},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t}(y);t.Function=_;var b=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionParameter},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.setDefaultValue=function(e){return this.setNode("defaultValue",e,0)},t.prototype.getDefaultValue=function(){return this.defaultValue},t}(a);t.FunctionParameter=b;var S=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionArgument},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.setValue=function(e){return this.setNode("value",e,0)},t.prototype.getValue=function(){return this.value},t}(a);t.FunctionArgument=S;var k=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.If},enumerable:!0,configurable:!0}),t.prototype.setExpression=function(e){return this.setNode("expression",e,0)},t.prototype.setElseClause=function(e){return this.setNode("elseClause",e)},t}(h);t.IfStatement=k;var C=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.For},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return this.setNode("variable",e,0)},t}(h);t.ForStatement=C;var T=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Each},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return this.setNode("variable",e,0)},t}(h);t.EachStatement=T;var E=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.While},enumerable:!0,configurable:!0}),t}(h);t.WhileStatement=E;var x=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Else},enumerable:!0,configurable:!0}),t}(h);t.ElseStatement=x;var w=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionDeclaration},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getParameters=function(){return this.parameters||(this.parameters=new u(this)),this.parameters},t}(h);t.FunctionDeclaration=w;var M=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MSViewPort},enumerable:!0,configurable:!0}),t}(h);t.MSViewPort=M;var L=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FontFace},enumerable:!0,configurable:!0}),t}(h);t.FontFace=L;var I=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.NestedProperties},enumerable:!0,configurable:!0}),t}(h);t.NestedProperties=I;var P=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Keyframe},enumerable:!0,configurable:!0}),t.prototype.setKeyword=function(e){return this.setNode("keyword",e,0)},t.prototype.getKeyword=function(){return this.keyword},t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t}(h);t.Keyframe=P;var N=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.KeyframeSelector},enumerable:!0,configurable:!0}),t}(h);t.KeyframeSelector=N;var A=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Import},enumerable:!0,configurable:!0}),t.prototype.setMedialist=function(e){return e?(e.attachTo(this),this.medialist=e,!0):!1},t}(a);t.Import=A;var R=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Namespace},enumerable:!0,configurable:!0}),t}(a);t.Namespace=R;var O=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Media},enumerable:!0,configurable:!0}),t}(h);t.Media=O;var D=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Document},enumerable:!0,configurable:!0}),t}(h);t.Document=D;var F=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),t.prototype.getMediums=function(){return this.mediums||(this.mediums=new u(this)),this.mediums},t}(a);t.Medialist=F;var B=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MediaQuery},enumerable:!0,configurable:!0}),t}(a);t.MediaQuery=B;var W=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Page},enumerable:!0,configurable:!0}),t}(h);t.Page=W;var U=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.PageBoxMarginBox},enumerable:!0,configurable:!0}),t}(h);t.PageBoxMarginBox=U;var j=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Expression},enumerable:!0,configurable:!0}),t}(a);t.Expression=j;var z=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.BinaryExpression},enumerable:!0,configurable:!0}),t.prototype.setLeft=function(e){return this.setNode("left",e)},t.prototype.getLeft=function(){return this.left},t.prototype.setRight=function(e){return this.setNode("right",e)},t.prototype.getRight=function(){return this.right},t.prototype.setOperator=function(e){return this.setNode("operator",e)},t.prototype.getOperator=function(){return this.operator},t}(a);t.BinaryExpression=z;var q=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Term},enumerable:!0,configurable:!0}),t.prototype.setOperator=function(e){return this.setNode("operator",e)},t.prototype.getOperator=function(){return this.operator},t.prototype.setExpression=function(e){return this.setNode("expression",e)},t.prototype.getExpression=function(){return this.expression},t}(a);t.Term=q;var V=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Operator},enumerable:!0,configurable:!0}),t}(a);t.Operator=V;var H=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.HexColorValue},enumerable:!0,configurable:!0}),t}(a);t.HexColorValue=H;var K=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.NumericValue},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){for(var e,t=this.getText(),n=0,r=".".charCodeAt(0),o="0".charCodeAt(0),i="9".charCodeAt(0),s=0,a=t.length;a>s&&(e=t.charCodeAt(s),e>=o&&i>=e||e===r);s++)n+=1;return{value:t.substring(0,n),unit:a>n?t.substring(n):void 0}},t}(a);t.NumericValue=K;var $=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.VariableDeclaration},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return e?(e.attachTo(this),this.variable=e,!0):!1},t.prototype.getName=function(){return this.variable?this.variable.getName():""},t.prototype.setValue=function(e){return e?(e.attachTo(this),this.value=e,!0):!1},t}(a);t.VariableDeclaration=$;var G=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Interpolation},enumerable:!0,configurable:!0}),t}(a);t.Interpolation=G;var X=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.VariableName},enumerable:!0,configurable:!0}),t.prototype.getName=function(){return this.getText()},t}(a);t.Variable=X;var Y=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.ExtendsReference},enumerable:!0,configurable:!0}),t.prototype.setSelector=function(e){return this.setNode("selector",e,0)},t.prototype.getSelector=function(){return this.selector},t.prototype.getName=function(){return this.selector?this.selector.getText():""},t}(a);t.ExtendsReference=Y;var Q=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MixinReference},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getArguments=function(){return this.arguments||(this.arguments=new u(this)),this.arguments},t.prototype.setContent=function(e){return this.setNode("content",e)},t.prototype.getContent=function(){return this.content},t}(a);t.MixinReference=Q;var J=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MixinDeclaration},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getParameters=function(){return this.parameters||(this.parameters=new u(this)),this.parameters},t.prototype.setGuard=function(e){return e&&(e.attachTo(this),this.guard=e),!1},t}(h);t.MixinDeclaration=J;var Z=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.getConditions=function(){return this.conditions||(this.conditions=new u(this)),this.conditions},t}(a);t.LessGuard=Z;var et=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.setVariable=function(e){return this.setNode("variable",e)},t}(a);t.GuardCondition=et;var tt=function(){function e(e,t,n,r,o,i){void 0===o&&(o=e.offset),void 0===i&&(i=e.length),this.node=e,this.rule=t,this.level=n,this.message=r||t.message,this.offset=o,this.length=i}return e.prototype.getRule=function(){return this.rule},e.prototype.getLevel=function(){return this.level},e.prototype.getOffset=function(){return this.offset},e.prototype.getLength=function(){return this.length},e.prototype.getNode=function(){return this.node},e.prototype.getMessage=function(){return this.message},e}();t.Marker=tt;var nt=function(){function e(){this.entries=[]}return e.entries=function(t){var n=new e;return t.accept(n),n.entries},e.prototype.visitNode=function(e){return e.isErroneous()&&e.collectIssues(this.entries),!0},e}();t.ParseErrorCollector=nt}),define("vs/languages/css/common/services/languageFacts",["require","exports","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/services/browsers","vs/base/common/strings"],function(e,t,n,r,o){function i(e){var t=e.getName();return t?o.equalsIgnoreCase(t,"rgb")||o.equalsIgnoreCase(t,"rgba")||o.equalsIgnoreCase(t,"hsl")||o.equalsIgnoreCase(t,"hsla"):!1}function s(e){if(e.type===n.NodeType.HexColorValue)return!0;if(e.type===n.NodeType.Function)return this.isColorConstructor(e);if(e.type===n.NodeType.Identifier){if(e.parent&&e.parent.type!==n.NodeType.Term)return!1;var r=e.getText().toLowerCase();if("none"===r)return!1;if(t.colors[r])return!0}return!1}function a(e){return e?(e=e.toLowerCase(),d().hasOwnProperty(e)):!1}function u(e){return e.browsers.count>1}function c(){return["@bottom-center","@bottom-left","@bottom-left-corner","@bottom-right","@bottom-right-corner","@left-bottom","@left-middle","@left-top","@right-bottom","@right-middle","@right-top","@top-center","@top-left","@top-left-corner","@top-right","@top-right-corner"]}function l(e){var t=e.description||"",n=this.getBrowserLabel(e.browsers);return n&&(t&&(t+="\n"),t=t+"("+n+")"),t}function p(e){var n="";if(!e||e.all||0===e.count)return null;for(var r in t.browserNames)if(e[r]){n.length>0&&(n+=", "),n+=t.browserNames[r];var o=e[r];o.length>0&&(n=n+" "+o)}return n}function h(e){var n={all:!1,FF:"",S:"",C:"",IE:"",O:"",count:0},r=0;return e?e.split(",").forEach(function(e){if(e=e.trim(),"all"===e)n.all=!0,r=Number.MAX_VALUE;else if("none"!==e)for(var o in t.browserNames)0===e.indexOf(o)&&(n[o]=e.substring(o.length).trim(),r++)}):(n.all=!0,r=Number.MAX_VALUE),n.count=r,n}function d(){if(!v){v={};for(var e=0,t=b.length;t>e;e++){var n=b[e];v[n.name]=new _(n)}}return v}function f(){if(!S){S=[];for(var e=0,t=k.length;t>e;e++){var n=k[e];S.push(new _(n))}}return S}function m(){if(!C){C=[];for(var e=0,t=T.length;t>e;e++){var n=T[e];E.push(new _(n))}}return C}function g(){if(!E){E=[];for(var e=0,t=x.length;t>e;e++){var n=x[e];E.push(new _(n))}}return E}t.colors={aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgrey:"#a9a9a9",darkgreen:"#006400",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",grey:"#808080",green:"#008000",greenyellow:"#adff2f",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgrey:"#d3d3d3",lightgreen:"#90ee90",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370d8",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#d87093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",red:"#ff0000",rebeccapurple:"#663399",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},t.colorKeywords={ActiveBorder:"Active window border.",ActiveCaption:"Active window caption.",AppWorkspace:"Background color of multiple document interface.",Background:"Desktop background.",ButtonFace:"The face background color for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonHighlight:"The color of the border facing the light source for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonShadow:"The color of the border away from the light source for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonText:"Text on push buttons.",CaptionText:"Text in caption, size box, and scrollbar arrow box.",currentColor:"The value of the 'color' property. The computed value of the 'currentColor' keyword is the computed value of the 'color' property. If the 'currentColor' keyword is set on the 'color' property itself, it is treated as 'color:inherit' at parse time.",GrayText:"Grayed (disabled) text. This color is set to #000 if the current display driver does not support a solid gray color.",Highlight:"Item(s) selected in a control.",HighlightText:"Text of item(s) selected in a control.",InactiveBorder:"Inactive window border.",InactiveCaption:"Inactive window caption.",InactiveCaptionText:"Color of text in an inactive caption.",InfoBackground:"Background color for tooltip controls.",InfoText:"Text color for tooltip controls.",Menu:"Menu background.",MenuText:"Text in menus.",Scrollbar:"Scroll bar gray area.",ThreeDDarkShadow:"The color of the darker (generally outer) of the two borders away from the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDFace:"The face background color for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDHighlight:"The color of the lighter (generally outer) of the two borders facing the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDLightShadow:"The color of the darker (generally inner) of the two borders facing the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDShadow:"The color of the lighter (generally inner) of the two borders away from the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",transparent:"Fully transparent. This keyword can be considered a shorthand for rgba(0,0,0,0) which is its computed value.",Window:"Window background.",WindowFrame:"Window frame.",WindowText:"Text in windows.",none:""},t.units={length:["em","rem","ex","px","cm","mm","in","pt","pc","cc"],angle:["deg","rad","grad"],time:["ms","s"],frequency:["hz","khz"],resolution:["dpi","dpcm"],percentage:["%"]},t.html5Tags=["a","abbr","address","area","article","aside","audio","b","base","bdi","bdo","blockquote","body","br","button","canvas","caption","cite","code","col","colgroup","data","datalist","dd","del","details","dfn","dialog","div","dl","dt","em","embed","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","iframe","img","input","ins","kbd","keygen","label","legend","li","link","main","map","mark","menu","menuitem","meta","meter","nav","noscript","object","ol","optgroup","option","output","p","param","pre","progress","q","rb","rp","rt","rtc","ruby","s","samp","script","section","select","small","source","span","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","title","tr","track","u","ul","var","video","wbr"],t.isColorConstructor=i,t.isColorValue=s,t.isKnownProperty=a,t.isCommonValue=u,t.getPageBoxDirectives=c,t.getEntryDescription=l,t.getBrowserLabel=p;
var v,y=function(){function e(e){this.data=e}return Object.defineProperty(e.prototype,"name",{get:function(){return this.data.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"description",{get:function(){return this.data.desc||r.descriptions[this.data.name]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"browsers",{get:function(){return this.browserEntry||(this.browserEntry=h(this.data.browsers)),this.browserEntry},enumerable:!0,configurable:!0}),e}(),_=function(){function e(e){this.data=e}return Object.defineProperty(e.prototype,"name",{get:function(){return this.data.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"description",{get:function(){return this.data.desc||r.descriptions[this.data.name]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"browsers",{get:function(){return this.browserEntry||(this.browserEntry=h(this.data.browsers)),this.browserEntry},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"restrictions",{get:function(){return this.data.restriction?this.data.restriction.split(",").map(function(e){return e.trim()}):[]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"values",{get:function(){return this.data.values?Array.isArray(this.data.values)?this.data.values.map(function(e){return new y(e)}):[new y(this.data.values.value)]:[]},enumerable:!0,configurable:!0}),e}(),b=r.data.css.properties;t.getProperties=d;var S,k=r.data.css.atdirectives;t.getAtDirectives=f;var C,T=r.data.css.pseudoelements;t.getPseudoElements=m;var E,x=r.data.css.pseudoclasses;t.getPseudoClasses=g,t.browserNames={FF:"Firefox",S:"Safari",C:"Chrome",IE:"IE",O:"Opera"}});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/css/common/parser/cssSymbols",["require","exports","./cssNodes","vs/base/common/arrays"],function(e,t,n,r){var o=function(){function e(e,t){this.offset=e,this.length=t,this.symbols=[],this.parent=null,this.children=[]}return e.prototype.addChild=function(e){this.children.push(e),e.setParent(this)},e.prototype.setParent=function(e){this.parent=e},e.prototype.findScope=function(e,t){return void 0===t&&(t=0),this.offset<=e&&this.offset+this.length>e+t||this.offset===e&&this.length===t?this.findInScope(e,t):null},e.prototype.findInScope=function(e,t){void 0===t&&(t=0);var n=e+t,o=r.findFirst(this.children,function(e){return e.offset>n});if(0===o)return this;var i=this.children[o-1];return i.offset<=e&&i.offset+i.length>=e+t?i.findInScope(e,t):this},e.prototype.addSymbol=function(e){this.symbols.push(e)},e.prototype.getSymbol=function(e,t){for(var n=0;n<this.symbols.length;n++){var r=this.symbols[n];if(r.name===e&&r.type===t)return r}return null},e.prototype.getSymbols=function(){return this.symbols},e}();t.Scope=o;var i=function(e){function t(){e.call(this,0,Number.MAX_VALUE)}return __extends(t,e),t}(o);t.GlobalScope=i;var s=function(){function e(e,t,n){this.name=e,this.node=t,this.type=n}return e}();t.Symbol=s;var a=function(){function e(e){this.scope=e}return e.prototype.addSymbol=function(e,t,n){if(-1!==e.offset){var r=this.scope.findScope(e.offset,e.length);r.addSymbol(new s(t,e,n))}},e.prototype.addScope=function(e){if(-1!==e.offset){var t=this.scope.findScope(e.offset,e.length);if(t.offset!==e.offset||t.length!==e.length){var n=new o(e.offset,e.length);return t.addChild(n),n}return t}return null},e.prototype.addSymbolToChildScope=function(e,t,n,r){if(e&&-1!==e.offset){var o=this.addScope(e);o.addSymbol(new s(n,t,r))}},e.prototype.visitNode=function(e){switch(e.type){case n.NodeType.Keyframe:return this.addSymbol(e,e.getName(),n.ReferenceType.Keyframe),!0;case n.NodeType.VariableDeclaration:return this.addSymbol(e,e.getName(),n.ReferenceType.Variable),!0;case n.NodeType.Ruleset:return this.visitRuleSet(e);case n.NodeType.MixinDeclaration:return this.addSymbol(e,e.getName(),n.ReferenceType.Mixin),!0;case n.NodeType.FunctionDeclaration:return this.addSymbol(e,e.getName(),n.ReferenceType.Function),!0;case n.NodeType.FunctionParameter:var t=e.getParent().getDeclarations();return t&&this.addSymbolToChildScope(t,e,e.getName(),n.ReferenceType.Variable),!0;case n.NodeType.Declarations:return this.addScope(e),!0;case n.NodeType.For:case n.NodeType.Each:var r=e,t=r.getDeclarations();return t&&this.addSymbolToChildScope(t,r.variable,r.variable.getName(),n.ReferenceType.Variable),!0}return!0},e.prototype.visitRuleSet=function(e){var t=this.scope.findScope(e.offset,e.length);return e.getSelectors().getChildren().forEach(function(e){e instanceof n.Selector&&1===e.getChildren().length&&t.addSymbol(new s(e.getChild(0).getText(),e,n.ReferenceType.Rule))}),!0},e}();t.ScopeBuilder=a;var u=function(){function e(e){this.global=new i,e.accept(new a(this.global))}return e.prototype.findSymbolsAtOffset=function(e,t){for(var n=this.global.findScope(e,0),r=[],o={};n;){for(var i=n.getSymbols(),s=0;s<i.length;s++){var a=i[s];a.node.offset<=e&&a.type===t&&!o[a.name]&&(r.push(a),o[a.name]=!0)}n=n.parent}return r},e.prototype.internalFindSymbol=function(e,t){var r=e;if(e.parent instanceof n.FunctionParameter&&e.parent.getParent()instanceof n.BodyDeclaration&&(r=e.parent.getParent().getDeclarations()),e.parent instanceof n.FunctionArgument&&e.parent.getParent()instanceof n.Function){var o=e.parent.getParent().getIdentifier();if(o){var i=this.internalFindSymbol(o,[n.ReferenceType.Function]);i&&(r=i.node.getDeclarations())}}if(!r)return null;for(var s=e.getText(),a=this.global.findScope(r.offset,r.length);a;){for(var u=0;u<t.length;u++){var c=t[u],l=a.getSymbol(s,c);if(l)return l}a=a.parent}return null},e.prototype.evaluateReferenceTypes=function(e){if(e instanceof n.Identifier){var t=e.referenceTypes;if(t)return t;var r=n.getParentDeclaration(e);if(r){var o=r.getNonPrefixedPropertyName();if(("animation"===o||"animation-name"===o)&&r.getValue()&&r.getValue().offset===e.offset)return[n.ReferenceType.Keyframe]}}else if(e instanceof n.Variable)return[n.ReferenceType.Variable];var i=e.findParent(n.NodeType.Selector);if(i)return[n.ReferenceType.Rule];var s=e.findParent(n.NodeType.ExtendsReference);return s?[n.ReferenceType.Rule]:null},e.prototype.findSymbolFromNode=function(e){if(!e)return null;for(;e.type===n.NodeType.Interpolation;)e=e.getParent();var t=this.evaluateReferenceTypes(e);return t?this.internalFindSymbol(e,t):null},e.prototype.matchesSymbol=function(e,t){if(!e)return null;for(;e.type===n.NodeType.Interpolation;)e=e.getParent();if(t.name.length!==e.length||t.name!==e.getText())return!1;var r=this.evaluateReferenceTypes(e);if(!r||-1===r.indexOf(t.type))return!1;var o=this.internalFindSymbol(e,r);return o===t},e.prototype.findSymbol=function(e,t,n){for(var r=this.global.findScope(n);r;){var o=r.getSymbol(e,t);if(o)return o;r=r.parent}return null},e}();t.Symbols=u}),define("vs/languages/css/common/services/occurrences",["require","exports","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/parser/cssSymbols"],function(e,t,n,r){function o(e,t){var o=new r.Symbols(e),i=n.getNodeAtOffset(e,t);if(!i)return null;var s=o.findSymbolFromNode(i);return s?s.node:null}function i(e,t){var o=[],i=n.getNodeAtOffset(e,t);if(!i||i.type===n.NodeType.Stylesheet)return o;var a=new r.Symbols(e),u=a.findSymbolFromNode(i),c=i.getText();return e.accept(function(e){if(u){if(a.matchesSymbol(e,u))return o.push({kind:s(e),type:u.type,node:e}),!1}else i.type===e.type&&i.length===e.length&&c===e.getText()&&o.push({kind:s(e),node:e,type:n.ReferenceType.Unknown});return!0}),o}function s(e){if(e.type===n.NodeType.Selector)return"write";if(e.parent)switch(e.parent.type){case n.NodeType.FunctionDeclaration:case n.NodeType.MixinDeclaration:case n.NodeType.Keyframe:case n.NodeType.VariableDeclaration:case n.NodeType.FunctionParameter:return"write"}return null}t.findDeclaration=o,t.findOccurrences=i}),define("vs/languages/css/common/services/intelliSense",["require","exports","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/parser/cssSymbols","vs/languages/css/common/services/languageFacts","vs/nls!vs/languages/css/common/cssWorker"],function(e,t,n,r,o,i){function s(e){return"undefined"!=typeof e}var a=function(){function e(e){void 0===e&&(e=null),this.variablePrefix=e}return e.prototype.getSymbolContext=function(){return this.symbolContext||(this.symbolContext=new r.Symbols(this.styleSheet)),this.symbolContext},e.prototype.getCompletionsAtPosition=function(e,t,r,o){this.offset=t.getOffsetFromPosition(o),this.position=o,this.currentWord=t.getWordUntilPosition(o).word,this.model=t,this.styleSheet=e.getStylesheet(r);var i=[],s=n.getNodePath(this.styleSheet,this.offset);this.isIncomplete=!1;for(var a=s.length-1;a>=0;a--){var u=s[a];if(u instanceof n.Property)this.getCompletionsForDeclarationProperty(i);else if(u instanceof n.Expression)this.getCompletionsForExpression(u,i);else if(u instanceof n.SimpleSelector){var c=u.findParent(n.NodeType.Ruleset);this.getCompletionsForSelector(c,i)}else u instanceof n.Declarations?this.getCompletionsForDeclarations(u,i):u instanceof n.VariableDeclaration?this.getCompletionsForVariableDeclaration(u,i):u instanceof n.RuleSet?this.getCompletionsForRuleSet(u,i):u instanceof n.Interpolation?this.getCompletionsForInterpolation(u,i):u instanceof n.FunctionArgument?this.getCompletionsForFunctionArguments(u,i):u instanceof n.FunctionDeclaration&&this.getCompletionsForFunctionDeclaration(u,i);if(i.length>0)return{currentWord:this.currentWord,suggestions:i,incomplete:this.isIncomplete}}if(this.getCompletionsForStylesheet(i),i.length>0)return{currentWord:this.currentWord,suggestions:i};if(this.variablePrefix&&0===this.currentWord.indexOf(this.variablePrefix)){if(this.getVariableProposals(i),i.length>0)return{currentWord:this.currentWord,suggestions:i};t.getAllUniqueWords(this.currentWord).forEach(function(e){i.push({type:"text",label:e,codeSnippet:e})})}return{currentWord:this.currentWord,suggestions:i}},e.prototype.getCompletionsForDeclarationProperty=function(e){var t=o.getProperties();for(var n in t)if(t.hasOwnProperty(n)){var r=t[n];r.browsers.count>1&&e.push({label:r.name,documentationLabel:o.getEntryDescription(r),codeSnippet:r.name+": ",type:"property"})}return e},e.prototype.getCompletionsForDeclarationValue=function(e,t){var n=e.getFullPropertyName(),r=o.getProperties()[n];if(r)this.getColorProposals(r,t),this.getValueEnumProposals(r,t),this.getUnitProposals(r,t);else{var i=new u;this.styleSheet.accept(new l(n,i)),i.getEntries().forEach(function(e){t.push({label:e,codeSnippet:e,type:"value"})})}return this.getVariableProposals(t),this.getTermProposals(t),t},e.prototype.getValueEnumProposals=function(e,t){if(e.values){var n="value";e.values.forEach(function(e){o.isCommonValue(e)&&t.push({label:e.name,documentationLabel:o.getEntryDescription(e),codeSnippet:e.name,type:n})})}return t},e.prototype.getCompletionsForInterpolation=function(e,t){return this.offset>=e.offset+2&&this.getVariableProposals(t),t},e.prototype.getVariableProposals=function(e){var t=this.getSymbolContext().findSymbolsAtOffset(this.offset,n.ReferenceType.Variable);return t.forEach(function(t){e.push({label:t.name,codeSnippet:t.name,type:"variable"})}),e},e.prototype.getUnitProposals=function(e,t){var n="0";if(this.currentWord.length>0){var r=this.currentWord.match(/-?\d[\.\d+]*/);r&&(n=r[0])}return e.restrictions.forEach(function(e){var r=o.units[e];r&&r.forEach(function(e){t.push({label:n+e,codeSnippet:n+e,type:"unit"})})}),this.isIncomplete=!0,t},e.prototype.getColorProposals=function(t,n){if(-1!==t.restrictions.indexOf("color")){for(var r in o.colors)n.push({label:r,documentationLabel:o.colors[r],codeSnippet:r,type:"#"+o.colors[r]});for(var r in o.colorKeywords)n.push({label:r,documentationLabel:o.colorKeywords[r],codeSnippet:r,type:"function"});var i=new u;this.styleSheet.accept(new p(i)),i.getEntries().forEach(function(e){n.push({label:e,codeSnippet:e,type:"#"+e})}),e.colorFunctions.forEach(function(e){n.push({label:e.func.substr(0,e.func.indexOf("(")),typeLabel:e.func,documentationLabel:e.desc,codeSnippet:e.func.replace(/\[?\$(\w+)\]?/g,"{{$1}}"),type:"function"})})}return n},e.prototype.getCompletionsForStylesheet=function(e){var t=this.styleSheet.findFirstChildBeforeOffset(this.offset);return t?t instanceof n.RuleSet?this.getCompletionsForRuleSet(t,e):e:this.getCompletionForTopLevel(e)},e.prototype.getCompletionForTopLevel=function(e){return o.getAtDirectives().forEach(function(t){t.browsers.count>0&&e.push({label:t.name,codeSnippet:t.name,documentationLabel:o.getEntryDescription(t),type:"keyword"})}),this.getCompletionsForSelector(null,e),e},e.prototype.getCompletionsForRuleSet=function(e,t){var r=e.getDeclarations(),o=r&&r.endsWith("}")&&this.offset>=r.offset+r.length;if(o)return this.getCompletionForTopLevel(t);var i=!r||this.offset<=r.offset;return i?this.getCompletionsForSelector(e,t):(e.findParent(n.NodeType.Ruleset),this.getCompletionsForDeclarations(e.getDeclarations(),t))},e.prototype.getCompletionsForSelector=function(e,t){o.getPseudoClasses().forEach(function(e){e.browsers.count>1&&t.push({label:e.name,codeSnippet:e.name,documentationLabel:o.getEntryDescription(e),type:"function"})}),o.getPseudoElements().forEach(function(e){e.browsers.count>1&&t.push({label:e.name,codeSnippet:e.name,documentationLabel:o.getEntryDescription(e),type:"function"})}),o.html5Tags.forEach(function(e){t.push({label:e,codeSnippet:e,type:"keyword"})});var r={};r[this.currentWord]=!0;var i=this.styleSheet.getTextProvider();if(this.styleSheet.accept(function(e){if(e.type===n.NodeType.SimpleSelector&&e.length>0){var o=i(e.offset,e.length);return"."!==o.charAt(0)||r[o]||(r[o]=!0,t.push({label:o,codeSnippet:o,type:"keyword"})),!1}return!0}),e&&e.isNested()){var s=e.getSelectors().findFirstChildBeforeOffset(this.offset);s&&0===e.getSelectors().getChildren().indexOf(s)&&this.getCompletionsForDeclarationProperty(t)}return t},e.prototype.getCompletionsForDeclarations=function(e,t){if(!e)return t;var r=e.findFirstChildBeforeOffset(this.offset);if(!r)return this.getCompletionsForDeclarationProperty(t);if(r instanceof n.Declaration){var o=r;return!s(o.colonPosition)||this.offset<=o.colonPosition||s(o.semicolonPosition)&&o.semicolonPosition<this.offset?this.offset===o.semicolonPosition+1?t:this.getCompletionsForDeclarationProperty(t):this.getCompletionsForDeclarationValue(o,t)}return t},e.prototype.getCompletionsForVariableDeclaration=function(e,t){return this.offset>e.colonPosition&&this.getVariableProposals(t),t},e.prototype.getCompletionsForExpression=function(e,t){var r=e.findParent(n.NodeType.Declaration);if(!r)return this.getTermProposals(t),t;var o=e.findChildAtOffset(this.offset,!0);return o?o instanceof n.NumericValue||o instanceof n.Identifier?this.getCompletionsForDeclarationValue(r,t):t:this.getCompletionsForDeclarationValue(r,t)},e.prototype.getCompletionsForFunctionArguments=function(e,t){return t},e.prototype.getCompletionsForFunctionDeclaration=function(e,t){var n=e.getDeclarations();return n&&this.offset>n.offset&&this.offset<n.offset+n.length&&this.getTermProposals(t),t},e.prototype.getTermProposals=function(e){var t=this.getSymbolContext().findSymbolsAtOffset(this.offset,n.ReferenceType.Function);return t.forEach(function(t){if(t.node instanceof n.FunctionDeclaration){var r=t.node,o=r.getParameters().getChildren().map(function(e){return e instanceof n.FunctionParameter?e.getName():e.getText()});e.push({label:t.name,typeLabel:t.name+"("+o.join(", ")+")",codeSnippet:t.name+"("+o.map(function(e){return"{{"+e+"}}"}).join(", ")+")",type:"function"})}}),e},e.colorFunctions=[{func:"rgb($red, $green, $blue)",desc:i.localize("vs_languages_css_common_services_intelliSense",0)},{func:"rgba($red, $green, $blue, $alpha)",desc:i.localize("vs_languages_css_common_services_intelliSense",1)},{func:"hsl($hue, $saturation, $lightness)",desc:i.localize("vs_languages_css_common_services_intelliSense",2)},{func:"hsla($hue, $saturation, $lightness, $alpha)",desc:i.localize("vs_languages_css_common_services_intelliSense",3)}],e}();t.CSSIntellisense=a;var u=function(){function e(){this.entries={}}return e.prototype.add=function(e){this.entries[e]=!0},e.prototype.getEntries=function(){return Object.keys(this.entries)},e}(),c=function(){function e(e){this.entries=e}return e.prototype.visitNode=function(e){return(e instanceof n.Identifier||e instanceof n.NumericValue||e instanceof n.HexColorValue)&&this.entries.add(e.getText()),!0},e}(),l=function(){function e(e,t){this.propertyName=e,this.entries=t}return e.prototype.matchesProperty=function(e){var t=e.getFullPropertyName();return this.propertyName===t},e.prototype.visitNode=function(e){if(e instanceof n.Declaration&&this.matchesProperty(e)){var t=e.getValue();t&&t.accept(new c(this.entries))}return!0},e}(),p=function(){function e(e){this.entries=e}return e.prototype.visitNode=function(e){return(e instanceof n.HexColorValue||e instanceof n.Function&&o.isColorConstructor(e))&&this.entries.add(e.getText()),!0},e}()}),define("vs/languages/css/common/level",["require","exports"],function(e,t){function n(e){switch(e){case"ignore":return r.Ignore;case"warning":return r.Warning;case"error":return r.Error}return null}!function(e){e[e.Ignore=1]="Ignore",e[e.Warning=2]="Warning",e[e.Error=4]="Error"}(t.Level||(t.Level={}));var r=t.Level;t.toLevel=n}),define("vs/languages/css/common/parser/cssScanner",["require","exports"],function(e,t){!function(e){e[e.Ident=0]="Ident",e[e.AtKeyword=1]="AtKeyword",e[e.String=2]="String",e[e.BadString=3]="BadString",e[e.BadUri=4]="BadUri",e[e.Hash=5]="Hash",e[e.Num=6]="Num",e[e.Percentage=7]="Percentage",e[e.Dimension=8]="Dimension",e[e.URI=9]="URI",e[e.UnicodeRange=10]="UnicodeRange",e[e.CDO=11]="CDO",e[e.CDC=12]="CDC",e[e.Colon=13]="Colon",e[e.SemiColon=14]="SemiColon",e[e.CurlyL=15]="CurlyL",e[e.CurlyR=16]="CurlyR",e[e.ParenthesisL=17]="ParenthesisL",e[e.ParenthesisR=18]="ParenthesisR",e[e.BracketL=19]="BracketL",e[e.BracketR=20]="BracketR",e[e.Whitespace=21]="Whitespace",e[e.Includes=22]="Includes",e[e.Dashmatch=23]="Dashmatch",e[e.SubstringOperator=24]="SubstringOperator",e[e.PrefixOperator=25]="PrefixOperator",e[e.SuffixOperator=26]="SuffixOperator",e[e.Delim=27]="Delim",e[e.EMS=28]="EMS",e[e.EXS=29]="EXS",e[e.Length=30]="Length",e[e.Angle=31]="Angle",e[e.Time=32]="Time",e[e.Freq=33]="Freq",e[e.Exclamation=34]="Exclamation",e[e.Resolution=35]="Resolution",e[e.Comma=36]="Comma",e[e.Charset=37]="Charset",e[e.EscapedJavaScript=38]="EscapedJavaScript",e[e.BadEscapedJavaScript=39]="BadEscapedJavaScript",e[e.SingleLineComment=40]="SingleLineComment",e[e.EOF=41]="EOF",e[e.CustomToken=42]="CustomToken"}(t.TokenType||(t.TokenType={}));var n=t.TokenType,r=function(){function e(e){this.source=e,this.len=e.length,this.position=0}return e.prototype.substring=function(e,t){return void 0===t&&(t=this.position),this.source.substring(e,t)},e.prototype.eos=function(){return this.len<=this.position},e.prototype.pos=function(){return this.position},e.prototype.goBackTo=function(e){this.position=e},e.prototype.goBack=function(e){this.position-=e},e.prototype.advance=function(e){this.position+=e},e.prototype.nextChar=function(){return this.source.charCodeAt(this.position++)||0},e.prototype.peekChar=function(e){return void 0===e&&(e=0),this.source.charCodeAt(this.position+e)||0},e.prototype.lookbackChar=function(e){return void 0===e&&(e=0),this.source.charCodeAt(this.position-e)||0},e.prototype.advanceIfChar=function(e){return e===this.source.charCodeAt(this.position)?(this.position++,!0):!1},e.prototype.advanceIfChars=function(e){var t;if(this.position+e.length>this.source.length)return!1;for(t=0;t<e.length;t++)if(this.source.charCodeAt(this.position+t)!==e[t])return!1;return this.advance(t),!0},e.prototype.advanceWhileChar=function(e){for(var t=this.position;this.position<this.len&&e(this.source.charCodeAt(this.position));)this.position++;return this.position-t},e}();t.MultiLineStream=r;var o="a".charCodeAt(0),i="c".charCodeAt(0),s="e".charCodeAt(0),a="f".charCodeAt(0),u="h".charCodeAt(0),c="i".charCodeAt(0),l="l".charCodeAt(0),p="p".charCodeAt(0),h="r".charCodeAt(0),d="s".charCodeAt(0),f="t".charCodeAt(0),m="u".charCodeAt(0),g="x".charCodeAt(0),v="z".charCodeAt(0),y="A".charCodeAt(0),_="E".charCodeAt(0),b="F".charCodeAt(0),S="I".charCodeAt(0),k="L".charCodeAt(0),C="P".charCodeAt(0),T="R".charCodeAt(0),E="U".charCodeAt(0),x="X".charCodeAt(0),w="Z".charCodeAt(0),M="0".charCodeAt(0),L="9".charCodeAt(0),I="~".charCodeAt(0),P="^".charCodeAt(0),N="=".charCodeAt(0),A="|".charCodeAt(0),R="-".charCodeAt(0),O="_".charCodeAt(0),D="%".charCodeAt(0),F="*".charCodeAt(0),B="(".charCodeAt(0),W=")".charCodeAt(0),U="<".charCodeAt(0),j=">".charCodeAt(0),z="@".charCodeAt(0),q="#".charCodeAt(0),V="$".charCodeAt(0),H="\\".charCodeAt(0),K="/".charCodeAt(0),$="\n".charCodeAt(0),G="\r".charCodeAt(0),X="\f".charCodeAt(0),Y='"'.charCodeAt(0),Q="'".charCodeAt(0),J=" ".charCodeAt(0),Z="	".charCodeAt(0),et=";".charCodeAt(0),tt=":".charCodeAt(0),nt="{".charCodeAt(0),rt="}".charCodeAt(0),ot="[".charCodeAt(0),it="]".charCodeAt(0),st=",".charCodeAt(0),at=".".charCodeAt(0),ut="!".charCodeAt(0),ct=[m,E,h,T,l,k,B,B],lt=[m,E,h,T,l,k,R,R,p,C,h,T,s,_,a,b,c,S,g,x,B,B],pt={};pt[et]=n.SemiColon,pt[tt]=n.Colon,pt[nt]=n.CurlyL,pt[rt]=n.CurlyR,pt[it]=n.BracketR,pt[ot]=n.BracketL,pt[B]=n.ParenthesisL,pt[W]=n.ParenthesisR,pt[st]=n.Comma;var ht={};ht.em=n.EMS,ht.ex=n.EXS,ht.px=n.Length,ht.cm=n.Length,ht.mm=n.Length,ht["in"]=n.Length,ht.pt=n.Length,ht.pc=n.Length,ht.deg=n.Angle,ht.rad=n.Angle,ht.grad=n.Angle,ht.ms=n.Time,ht.s=n.Time,ht.hz=n.Freq,ht.khz=n.Freq,ht["%"]=n.Percentage,ht.dpi=n.Resolution,ht.dpcm=n.Resolution;var dt=function(){function e(){this.ignoreComment=!0}return e.prototype.setSource=function(e){this.stream=new r(e)},e.prototype.finishToken=function(e,t){return e.len=this.stream.pos()-e.offset,e.type=t,e.text=this.stream.substring(e.offset),e},e.prototype.substring=function(e,t){return this.stream.substring(e,e+t)},e.prototype.pos=function(){return this.stream.pos()},e.prototype.goBackTo=function(e){this.stream.goBackTo(e)},e.prototype.scan=function(e){void 0===e&&(e=!0);var t={type:void 0,text:void 0,offset:this.stream.pos(),len:0};if(this.whitespace())return e?this.scan(e):this.finishToken(t,n.Whitespace);if(this.comment())return this.ignoreComment?this.scan(e):this.finishToken(t,r);if(this.stream.eos())return this.finishToken(t,n.EOF);var r=this.url();if(null!==r)return this.finishToken(t,r);if(this.ident())return this.finishToken(t,n.Ident);if(this.stream.advanceIfChar(z))return this.stream.advanceIfChars([i,u,o,h,d,s,f])?this.finishToken(t,n.Charset):this.ident()?this.finishToken(t,n.AtKeyword):this.finishToken(t,n.Delim);if(this.stream.advanceIfChar(q))return this.name()?this.finishToken(t,n.Hash):this.finishToken(t,n.Delim);if(this.stream.advanceIfChar(ut))return this.finishToken(t,n.Exclamation);if(this._number()){var a=this.stream.pos();if(this.stream.advanceIfChar(D))return this.finishToken(t,n.Percentage);if(this.dimension()){var c=this.stream.substring(a).toLowerCase(),r=ht[c];return"undefined"!=typeof r?this.finishToken(t,r):this.finishToken(t,n.Dimension)}return this.finishToken(t,n.Num)}var r=this._string();if(null!==r)return this.finishToken(t,r);if(this.stream.advanceIfChars([U,ut,R,R]))return this.finishToken(t,n.CDO);if(this.stream.advanceIfChars([R,R,j]))return this.finishToken(t,n.CDC);var r=pt[this.stream.peekChar()];return"undefined"!=typeof r?(this.stream.advance(1),this.finishToken(t,r)):this.stream.peekChar(0)===I&&this.stream.peekChar(1)===N?(this.stream.advance(2),this.finishToken(t,n.Includes)):this.stream.peekChar(0)===A&&this.stream.peekChar(1)===N?(this.stream.advance(2),this.finishToken(t,n.Dashmatch)):this.stream.peekChar(0)===F&&this.stream.peekChar(1)===N?(this.stream.advance(2),this.finishToken(t,n.SubstringOperator)):this.stream.peekChar(0)===P&&this.stream.peekChar(1)===N?(this.stream.advance(2),this.finishToken(t,n.PrefixOperator)):this.stream.peekChar(0)===V&&this.stream.peekChar(1)===N?(this.stream.advance(2),this.finishToken(t,n.SuffixOperator)):(this.stream.nextChar(),this.finishToken(t,n.Delim))},e.prototype.matchWordAnyCase=function(e){var t=0;return this.stream.advanceWhileChar(function(n){var r=e[t]===n||e[t+1]===n;return r&&(t+=2),r}),t===e.length?!0:(this.stream.goBack(t/2),!1)},e.prototype.comment=function(){if(this.stream.advanceIfChars([K,F])){var e=!1,t=!1;return this.stream.advanceWhileChar(function(n){return t&&n===K?(e=!0,!1):(t=n===F,!0)}),e&&this.stream.advance(1),!0}return!1},e.prototype._number=function(){var e,t=0;return this.stream.peekChar()===at&&(t=1),e=this.stream.peekChar(t),e>=M&&L>=e?(this.stream.advance(t+1),this.stream.advanceWhileChar(function(e){return e>=M&&L>=e||0===t&&e===at}),!0):!1},e.prototype._string=function(){if(this.stream.peekChar()===Q||this.stream.peekChar()===Y){var e=this.stream.nextChar(),t=!1,r=-1;return this.stream.advanceWhileChar(function(n){switch(r=n,n){case H:return t=!0,!0;case X:case $:case G:case e:var o=t;return t=!1,o;default:return t=!1,!0}}),r===e?(this.stream.nextChar(),n.String):n.BadString}return null},e.prototype.url=function(){if(this.matchWordAnyCase(ct)||this.matchWordAnyCase(lt)){this.whitespace();var e=n.URI,t=this._string();return t===n.BadString?e=n.BadUri:null===t&&(this.stream.advanceWhileChar(function(e){return e!==W}),e=n.URI),this.whitespace(),this.stream.advanceIfChar(W)?e:n.BadUri}return null},e.prototype.whitespace=function(){var e=this.stream.advanceWhileChar(function(e){return e===J||e===Z||e===$||e===X||e===G});return e>0},e.prototype.name=function(){var e=this.stream.peekChar();return this.nmchar(e)?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.ident=function(){var e=this.stream.peekChar();return this.nmstart(e)||e===R&&this.nmstart(this.stream.peekChar(1))?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.dimension=function(){var e=this.stream.peekChar();return this.nmstart(e)?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.nmstart=function(e){return e===O||e>=o&&v>=e||e>=y&&w>=e||e>=128&&65535>=e?!0:!1},e.prototype.nmchar=function(e){return this.nmstart(e)||e===R||e>=M&&L>=e?!0:!1},e}();t.Scanner=dt}),define("vs/languages/css/common/parser/cssErrors",["require","exports","vs/nls!vs/languages/css/common/cssWorker"],function(e,t,n){var r=function(){function e(e,t){this.id=e,this.message=t}return e}();t.CSSIssueType=r,t.ParseError={NumberExpected:new r("css-numberexpected",n.localize("vs_languages_css_common_parser_cssErrors",0)),ConditionExpected:new r("css-conditionexpected",n.localize("vs_languages_css_common_parser_cssErrors",1)),RuleOrSelectorExpected:new r("css-ruleorselectorexpected",n.localize("vs_languages_css_common_parser_cssErrors",2)),DotExpected:new r("css-dotexpected",n.localize("vs_languages_css_common_parser_cssErrors",3)),ColonExpected:new r("css-colonexpected",n.localize("vs_languages_css_common_parser_cssErrors",4)),SemiColonExpected:new r("css-semicolonexpected",n.localize("vs_languages_css_common_parser_cssErrors",5)),TermExpected:new r("css-termexpected",n.localize("vs_languages_css_common_parser_cssErrors",6)),ExpressionExpected:new r("css-expressionexpected",n.localize("vs_languages_css_common_parser_cssErrors",7)),OperatorExpected:new r("css-operatorexpected",n.localize("vs_languages_css_common_parser_cssErrors",8)),IdentifierExpected:new r("css-identifierexpected",n.localize("vs_languages_css_common_parser_cssErrors",9)),PercentageExpected:new r("css-percentageexpected",n.localize("vs_languages_css_common_parser_cssErrors",10)),URIOrStringExpected:new r("css-uriorstringexpected",n.localize("vs_languages_css_common_parser_cssErrors",11)),URIExpected:new r("css-uriexpected",n.localize("vs_languages_css_common_parser_cssErrors",12)),VariableNameExpected:new r("css-varnameexpected",n.localize("vs_languages_css_common_parser_cssErrors",13)),VariableValueExpected:new r("css-varvalueexpected",n.localize("vs_languages_css_common_parser_cssErrors",14)),PropertyValueExpected:new r("css-propertyvalueexpected",n.localize("vs_languages_css_common_parser_cssErrors",15)),LeftCurlyExpected:new r("css-lcurlyexpected",n.localize("vs_languages_css_common_parser_cssErrors",16)),RightCurlyExpected:new r("css-rcurlyexpected",n.localize("vs_languages_css_common_parser_cssErrors",17)),LeftSquareBracketExpected:new r("css-rbracketexpected",n.localize("vs_languages_css_common_parser_cssErrors",18)),RightSquareBracketExpected:new r("css-lbracketexpected",n.localize("vs_languages_css_common_parser_cssErrors",19)),LeftParenthesisExpected:new r("css-lparentexpected",n.localize("vs_languages_css_common_parser_cssErrors",20)),RightParenthesisExpected:new r("css-rparentexpected",n.localize("vs_languages_css_common_parser_cssErrors",21)),CommaExpected:new r("css-commaexpected",n.localize("vs_languages_css_common_parser_cssErrors",22)),PageDirectiveOrDeclarationExpected:new r("css-pagedirordeclexpected",n.localize("vs_languages_css_common_parser_cssErrors",23)),UnknownAtRule:new r("css-unknownatrule",n.localize("vs_languages_css_common_parser_cssErrors",24)),UnknownKeyword:new r("css-unknownkeyword",n.localize("vs_languages_css_common_parser_cssErrors",25)),SelectorExpected:new r("css-selectorexpected",n.localize("vs_languages_css_common_parser_cssErrors",26)),StringLiteralExpected:new r("css-stringliteralexpected",n.localize("vs_languages_css_common_parser_cssErrors",27))}}),define("vs/languages/css/common/parser/cssParser",["require","exports","vs/base/common/types","./cssScanner","./cssNodes","vs/languages/css/common/level","./cssErrors","vs/languages/css/common/services/languageFacts"],function(e,t,n,r,o,i,s,a){var u=function(){function e(e){void 0===e&&(e=new r.Scanner),this.scanner=e,this.token=null,this.prevToken=null}return e.prototype.peek=function(e,t,n){return void 0===n&&(n=!0),e!==this.token.type?!1:"undefined"!=typeof t?n?t.toLowerCase()===this.token.text.toLowerCase():t===this.token.text:!0},e.prototype.hasWhitespace=function(){return this.prevToken&&this.prevToken.offset+this.prevToken.len!==this.token.offset},e.prototype.consumeToken=function(){this.prevToken=this.token,this.token=this.scanner.scan()},e.prototype.mark=function(){return{prev:this.prevToken,curr:this.token,pos:this.scanner.pos()}},e.prototype.restoreAtMark=function(e){this.prevToken=e.prev,this.token=e.curr,this.scanner.goBackTo(e.pos)},e.prototype.acceptOne=function(e,t,n){void 0===n&&(n=!0);for(var r=0;r<t.length;r++)if(this.peek(e,t[r],n))return this.consumeToken(),!0;return!1},e.prototype.accept=function(e,t,n){return void 0===n&&(n=!0),this.peek(e,t,n)?(this.consumeToken(),!0):!1},e.prototype.resync=function(e,t){for(;;){if(e&&-1!==e.indexOf(this.token.type))return this.consumeToken(),!0;if(t&&-1!==t.indexOf(this.token.type))return!0;if(this.token.type===r.TokenType.EOF)return!1;this.token=this.scanner.scan()}return!1},e.prototype.createNode=function(e){return new o.Node(this.token.offset,this.token.len,e)},e.prototype.create=function(e){return n.create(e,this.token.offset,this.token.len)},e.prototype.finish=function(e,t,n,r){if(!(e instanceof o.Nodelist)&&(t&&this.markError(e,t,n,r),null!==this.prevToken)){var i=this.prevToken.offset+this.prevToken.len;e.length=i>e.offset?i-e.offset:0}return e},e.prototype.markError=function(e,t,n,r){this.token!==this.lastErrorToken&&(e.addIssue(new o.Marker(e,t,i.Level.Error,null,this.token.offset,this.token.len)),this.lastErrorToken=this.token),(n||r)&&this.resync(n,r)},e.prototype.parseStylesheet=function(e){var t=e.getVersionId(),n=function(n,r){if(e.getVersionId()!==t)throw new Error("Underlying model has changed, AST is no longer valid");var o=e.getRangeFromOffsetAndLength(n,r);return e.getValueInRange(o)};return this.internalParse(e.getValue(),this._parseStylesheet,n)
},e.prototype.internalParse=function(e,t,n){this.scanner.setSource(e),this.token=this.scanner.scan();var r=t.bind(this)();return r&&(r.textProvider=n?n:function(t,n){return e.substr(t,n)}),r},e.prototype._parseStylesheet=function(){var e=this.create(o.Stylesheet);e.addChild(this._parseCharset());var t=!1;do{var n=!1;do{n=!1;var i=this._parseStylesheetStatement();for(i&&(e.addChild(i),n=!0,t=!1,this.peek(r.TokenType.EOF)||!this._needsSemicolonAfter(i)||this.accept(r.TokenType.SemiColon)||this.markError(e,s.ParseError.SemiColonExpected));this.accept(r.TokenType.SemiColon)||this.accept(r.TokenType.CDO)||this.accept(r.TokenType.CDC);)n=!0,t=!1}while(n);if(this.peek(r.TokenType.EOF))break;t||(this.peek(r.TokenType.AtKeyword)?this.markError(e,s.ParseError.UnknownAtRule):this.markError(e,s.ParseError.RuleOrSelectorExpected),t=!0),this.consumeToken()}while(!this.peek(r.TokenType.EOF));return this.finish(e)},e.prototype._parseStylesheetStatement=function(){return this._parseRuleset(!1)||this._parseImport()||this._parseMedia()||this._parsePage()||this._parseFontFace()||this._parseKeyframe()||this._parseMSViewPort()||this._parseNamespace()||this._parseDocument()},e.prototype._tryParseRuleset=function(e){var t=this.mark();if(this._parseSelector(e)){for(;this.accept(r.TokenType.Comma)&&this._parseSelector(e););if(this.accept(r.TokenType.CurlyL))return this.restoreAtMark(t),this._parseRuleset(e)}return this.restoreAtMark(t),null},e.prototype._parseRuleset=function(e){void 0===e&&(e=!1);var t=this.create(o.RuleSet);if(!t.getSelectors().addChild(this._parseSelector(e)))return null;for(;this.accept(r.TokenType.Comma)&&t.getSelectors().addChild(this._parseSelector(e)););return this._parseBody(t,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseRuleSetDeclaration=function(){return this._parseDeclaration()},e.prototype._needsSemicolonAfter=function(e){switch(e.type){case o.NodeType.Keyframe:case o.NodeType.MSViewPort:case o.NodeType.Media:case o.NodeType.Ruleset:case o.NodeType.Media:case o.NodeType.Namespace:case o.NodeType.If:case o.NodeType.For:case o.NodeType.Each:case o.NodeType.While:case o.NodeType.MixinDeclaration:case o.NodeType.FunctionDeclaration:return!1;case o.NodeType.VariableDeclaration:case o.NodeType.ExtendsReference:case o.NodeType.MixinContent:case o.NodeType.ReturnStatement:case o.NodeType.MediaQuery:case o.NodeType.Debug:case o.NodeType.Import:return!0;case o.NodeType.MixinReference:return!e.getContent();case o.NodeType.Declaration:return!e.getNestedProperties()}return!1},e.prototype._parseDeclarations=function(e){var t=this.create(o.Declarations);if(!this.accept(r.TokenType.CurlyL))return null;for(var n=e();t.addChild(n)&&!this.peek(r.TokenType.CurlyR);){if(this._needsSemicolonAfter(n)&&!this.accept(r.TokenType.SemiColon))return this.finish(t,s.ParseError.SemiColonExpected,[r.TokenType.SemiColon,r.TokenType.CurlyR]);for(;this.accept(r.TokenType.SemiColon););n=e()}return this.accept(r.TokenType.CurlyR)?this.finish(t):this.finish(t,s.ParseError.RightCurlyExpected,[r.TokenType.CurlyR,r.TokenType.SemiColon])},e.prototype._parseBody=function(e,t){return e.setDeclarations(this._parseDeclarations(t))?this.finish(e):this.finish(e,s.ParseError.LeftCurlyExpected,[r.TokenType.CurlyR,r.TokenType.SemiColon])},e.prototype._parseSelector=function(e){var t=this.create(o.Selector),n=!1;for(e&&(n=t.addChild(this._parseCombinator()));t.addChild(this._parseSimpleSelector());)n=!0,t.addChild(this._parseCombinator());return n?this.finish(t):null},e.prototype._parseDeclaration=function(e){var t=this.create(o.Declaration);return t.setProperty(this._parseProperty())?this.accept(r.TokenType.Colon)?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?(t.addChild(this._parsePrio()),this.peek(r.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)):this.finish(t,s.ParseError.PropertyValueExpected)):this.finish(t,s.ParseError.ColonExpected,[r.TokenType.Colon],e):null},e.prototype._tryToParseDeclaration=function(){var e=this.mark();return this._parseProperty()&&this.accept(r.TokenType.Colon)?(this.restoreAtMark(e),this._parseDeclaration()):(this.restoreAtMark(e),null)},e.prototype._parseProperty=function(){var e=this.create(o.Property),t=this.mark();return(this.accept(r.TokenType.Delim,"*")||this.accept(r.TokenType.Delim,"_"))&&this.hasWhitespace()?(this.restoreAtMark(t),null):e.setIdentifier(this._parseIdent())?this.finish(e):null},e.prototype._parseCharset=function(){var e=this.create(o.Node);return this.accept(r.TokenType.Charset)?this.accept(r.TokenType.String)?this.accept(r.TokenType.SemiColon)?this.finish(e):this.finish(e,s.ParseError.SemiColonExpected):this.finish(e,s.ParseError.IdentifierExpected):null},e.prototype._parseImport=function(){var e=this.create(o.Import);return this.accept(r.TokenType.AtKeyword,"@import")?this.accept(r.TokenType.URI)||this.accept(r.TokenType.String)?(e.setMedialist(this._parseMediaList()),this.finish(e)):this.finish(e,s.ParseError.URIOrStringExpected):null},e.prototype._parseNamespace=function(){var e=this.create(o.Namespace);return this.accept(r.TokenType.AtKeyword,"@namespace")?(e.addChild(this._parseIdent()),this.accept(r.TokenType.URI)||this.accept(r.TokenType.String)?this.accept(r.TokenType.SemiColon)?this.finish(e):this.finish(e,s.ParseError.SemiColonExpected):this.finish(e,s.ParseError.URIExpected,[r.TokenType.SemiColon])):null},e.prototype._parseFontFace=function(){if(!this.peek(r.TokenType.AtKeyword,"@font-face"))return null;var e=this.create(o.FontFace);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseMSViewPort=function(){if(!this.peek(r.TokenType.AtKeyword,"@-ms-viewport"))return null;var e=this.create(o.MSViewPort);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseKeyframe=function(){var e=this.create(o.Keyframe),t=this.create(o.Node);return this.accept(r.TokenType.AtKeyword,"@keyframes")||this.accept(r.TokenType.AtKeyword,"@-webkit-keyframes")||this.accept(r.TokenType.AtKeyword,"@-ms-keyframes")||this.accept(r.TokenType.AtKeyword,"@-moz-keyframes")||this.accept(r.TokenType.AtKeyword,"@-o-keyframes")?(e.setKeyword(this.finish(t)),"@-ms-keyframes"===t.getText()&&this.markError(t,s.ParseError.UnknownKeyword),e.setIdentifier(this._parseIdent([o.ReferenceType.Keyframe]))?this._parseBody(e,this._parseKeyframeSelector.bind(this)):this.finish(e,s.ParseError.IdentifierExpected,[r.TokenType.CurlyR])):null},e.prototype._parseKeyframeSelector=function(){var e=this.create(o.KeyframeSelector);if(!e.addChild(this._parseIdent())&&!this.accept(r.TokenType.Percentage))return null;for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parseIdent())&&!this.accept(r.TokenType.Percentage))return this.finish(e,s.ParseError.PercentageExpected);return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseMediaDeclaration=function(){return this._tryParseRuleset(!1)||this._tryToParseDeclaration()||this._parseStylesheetStatement()},e.prototype._parseMedia=function(){var e=this.create(o.Media);if(!this.accept(r.TokenType.AtKeyword,"@media"))return null;if(!e.addChild(this._parseMediaQuery([r.TokenType.CurlyL])))return this.finish(e,s.ParseError.IdentifierExpected);for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parseMediaQuery([r.TokenType.CurlyL])))return this.finish(e,s.ParseError.IdentifierExpected);return this._parseBody(e,this._parseMediaDeclaration.bind(this))},e.prototype._parseMediaQuery=function(e){var t=this.create(o.MediaQuery),n=!0,i=!1;if(!this.peek(r.TokenType.ParenthesisL)){if(this.accept(r.TokenType.Ident,"only",!0)||this.accept(r.TokenType.Ident,"not",!0),!t.addChild(this._parseIdent()))return null;i=!0,n=this.accept(r.TokenType.Ident,"and",!0)}for(;n;){if(!this.accept(r.TokenType.ParenthesisL))return i?this.finish(t,s.ParseError.LeftParenthesisExpected,[],e):null;if(!t.addChild(this._parseMediaFeatureName()))return this.finish(t,s.ParseError.IdentifierExpected,[],e);if(this.accept(r.TokenType.Colon)&&!t.addChild(this._parseExpr()))return this.finish(t,s.ParseError.TermExpected,[],e);if(!this.accept(r.TokenType.ParenthesisR))return this.finish(t,s.ParseError.RightParenthesisExpected,[],e);n=this.accept(r.TokenType.Ident,"and",!0)}return t},e.prototype._parseMediaFeatureName=function(){return this._parseIdent()},e.prototype._parseMediaList=function(){var e=this.create(o.Medialist);if(e.getMediums().addChild(this._parseMedium())){for(;this.accept(r.TokenType.Comma);)if(!e.getMediums().addChild(this._parseMedium()))return this.finish(e,s.ParseError.IdentifierExpected);return this.finish(e)}return null},e.prototype._parseMedium=function(){var e=this.create(o.Node);return e.addChild(this._parseIdent())?this.finish(e):null},e.prototype._parsePageDeclaration=function(){return this._parsePageMarginBox()||this._parseRuleSetDeclaration()},e.prototype._parsePage=function(){var e=this.create(o.Page);if(!this.accept(r.TokenType.AtKeyword,"@Page"))return null;if(e.addChild(this._parsePageSelector()))for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parsePageSelector()))return this.finish(e,s.ParseError.IdentifierExpected);return this._parseBody(e,this._parsePageDeclaration.bind(this))},e.prototype._parsePageMarginBox=function(){var e=this.create(o.PageBoxMarginBox);return this.peek(r.TokenType.AtKeyword)?(this.acceptOne(r.TokenType.AtKeyword,a.getPageBoxDirectives())||this.markError(e,s.ParseError.UnknownAtRule,[],[r.TokenType.CurlyL]),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))):null},e.prototype._parsePageSelector=function(){var e=this.create(o.Node);return this.peek(r.TokenType.Ident)||this.peek(r.TokenType.Colon)?(e.addChild(this._parseIdent()),this.accept(r.TokenType.Colon)&&!e.addChild(this._parseIdent())?this.finish(e,s.ParseError.IdentifierExpected):this.finish(e)):null},e.prototype._parseDocument=function(){var e=this.create(o.Document);return this.accept(r.TokenType.AtKeyword,"@-moz-document")?(this.resync([],[r.TokenType.CurlyL]),this._parseBody(e,this._parseStylesheetStatement.bind(this))):null},e.prototype._parseOperator=function(){var e=this.createNode(o.NodeType.Operator);return this.accept(r.TokenType.Delim,"/")||this.accept(r.TokenType.Delim,"*")||this.accept(r.TokenType.Delim,"+")||this.accept(r.TokenType.Delim,"-")||this.accept(r.TokenType.Dashmatch)||this.accept(r.TokenType.Includes)||this.accept(r.TokenType.SubstringOperator)||this.accept(r.TokenType.PrefixOperator)||this.accept(r.TokenType.SuffixOperator)||this.accept(r.TokenType.Delim,"=")?this.finish(e):null},e.prototype._parseUnaryOperator=function(){var e=this.create(o.Node);return this.accept(r.TokenType.Delim,"+")||this.accept(r.TokenType.Delim,"-")?this.finish(e):null},e.prototype._parseCombinator=function(){var e=this.create(o.Node);return this.accept(r.TokenType.Delim,">")?(e.type=o.NodeType.SelectorCombinatorParent,this.finish(e)):this.accept(r.TokenType.Delim,"+")?(e.type=o.NodeType.SelectorCombinatorSibling,this.finish(e)):this.accept(r.TokenType.Delim,"~")?(e.type=o.NodeType.SelectorCombinatorAllSiblings,this.finish(e)):null},e.prototype._parseSimpleSelector=function(){var e=this.create(o.SimpleSelector),t=0;for(e.addChild(this._parseElementName())&&t++;(0===t||!this.hasWhitespace())&&e.addChild(this._parseSimpleSelectorBody());)t++;return t>0?this.finish(e):null},e.prototype._parseSimpleSelectorBody=function(){return this._parsePseudo()||this._parseHash()||this._parseClass()||this._parseAttrib()},e.prototype._parseSelectorIdent=function(){return this._parseIdent()},e.prototype._parseHash=function(){if(!this.peek(r.TokenType.Hash)&&!this.peek(r.TokenType.Delim,"#"))return null;var e=this.createNode(o.NodeType.IdentifierSelector);if(this.accept(r.TokenType.Delim,"#")){if(this.hasWhitespace()||!e.addChild(this._parseSelectorIdent()))return this.finish(e,s.ParseError.IdentifierExpected)}else this.consumeToken();return this.finish(e)},e.prototype._parseClass=function(){if(!this.peek(r.TokenType.Delim,"."))return null;var e=this.createNode(o.NodeType.ClassSelector);return this.consumeToken(),this.hasWhitespace()||!e.addChild(this._parseSelectorIdent())?this.finish(e,s.ParseError.IdentifierExpected):this.finish(e)},e.prototype._parseElementName=function(){var e=this.createNode(o.NodeType.ElementNameSelector);return e.addChild(this._parseSelectorIdent())||this.accept(r.TokenType.Delim,"*")?this.finish(e):null},e.prototype._parseAttrib=function(){if(!this.peek(r.TokenType.BracketL))return null;var e=this.createNode(o.NodeType.AttributeSelector);return this.consumeToken(),!e.addChild(this._parseBinaryExpr()),this.accept(r.TokenType.BracketR)?this.finish(e):this.finish(e,s.ParseError.RightSquareBracketExpected)},e.prototype._parsePseudo=function(){if(!this.peek(r.TokenType.Colon))return null;var e=this.mark(),t=this.createNode(o.NodeType.PseudoSelector);return this.consumeToken(),!this.hasWhitespace()&&this.accept(r.TokenType.Colon),this.hasWhitespace()?(this.restoreAtMark(e),null):t.addChild(this._parseIdent())?this.hasWhitespace()||!this.accept(r.TokenType.ParenthesisL)||(t.addChild(this._parseBinaryExpr()||this._parseSimpleSelector()),this.accept(r.TokenType.ParenthesisR))?this.finish(t):this.finish(t,s.ParseError.RightParenthesisExpected):this.finish(t,s.ParseError.IdentifierExpected)},e.prototype._parsePrio=function(){if(!this.peek(r.TokenType.Exclamation))return null;var e=this.createNode(o.NodeType.Prio);return this.accept(r.TokenType.Exclamation)&&this.accept(r.TokenType.Ident,"important",!0)?this.finish(e):null},e.prototype._parseExpr=function(e){void 0===e&&(e=!1);var t=this.create(o.Expression);if(!t.addChild(this._parseBinaryExpr()))return null;for(;;){if(this.peek(r.TokenType.Comma)){if(e)return this.finish(t);this.consumeToken()}if(!t.addChild(this._parseBinaryExpr()))break}return this.finish(t)},e.prototype._parseBinaryExpr=function(e,t){var n=this.create(o.BinaryExpression);if(!n.setLeft(e||this._parseTerm()))return null;if(!n.setOperator(t||this._parseOperator()))return this.finish(n);if(!n.setRight(this._parseTerm()))return this.finish(n,s.ParseError.TermExpected);n=this.finish(n);var r=this._parseOperator();return r&&(n=this._parseBinaryExpr(n,r)),this.finish(n)},e.prototype._parseTerm=function(){var e=this.create(o.Term);return e.setOperator(this._parseUnaryOperator()),e.setExpression(this._parseFunction())||e.setExpression(this._parseIdent())||e.setExpression(this._parseURILiteral())||e.setExpression(this._parseStringLiteral())||e.setExpression(this._parseNumeric())||e.setExpression(this._parseHexColor())?this.finish(e):null},e.prototype._parseNumeric=function(){var e=this.create(o.NumericValue);return this.accept(r.TokenType.Num)||this.accept(r.TokenType.Percentage)||this.accept(r.TokenType.Resolution)||this.accept(r.TokenType.Length)||this.accept(r.TokenType.EMS)||this.accept(r.TokenType.EXS)||this.accept(r.TokenType.Angle)||this.accept(r.TokenType.Time)||this.accept(r.TokenType.Dimension)||this.accept(r.TokenType.Freq)?this.finish(e):null},e.prototype._parseStringLiteral=function(){var e=this.createNode(o.NodeType.StringLiteral);return this.accept(r.TokenType.String)||this.accept(r.TokenType.BadString)?this.finish(e):null},e.prototype._parseURILiteral=function(){var e=this.createNode(o.NodeType.URILiteral);return this.accept(r.TokenType.URI)||this.accept(r.TokenType.BadUri)?this.finish(e):null},e.prototype._parseIdent=function(e){var t=this.create(o.Identifier);return e&&(t.referenceTypes=e),this.accept(r.TokenType.Ident)?this.finish(t):null},e.prototype._parseFunction=function(){var e=this.mark(),t=this.create(o.Function);if(!t.setIdentifier(this._parseFunctionIdentifier()))return null;if(this.hasWhitespace()||!this.accept(r.TokenType.ParenthesisL))return this.restoreAtMark(e),null;if(t.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(r.TokenType.Comma);)if(!t.getArguments().addChild(this._parseFunctionArgument()))return this.finish(t,s.ParseError.ExpressionExpected);return this.accept(r.TokenType.ParenthesisR)?this.finish(t):this.finish(t,s.ParseError.RightParenthesisExpected)},e.prototype._parseFunctionIdentifier=function(){var e=this.create(o.Identifier);if(e.referenceTypes=[o.ReferenceType.Function],this.accept(r.TokenType.Ident,"progid")){if(this.accept(r.TokenType.Colon))for(;this.accept(r.TokenType.Ident)&&this.accept(r.TokenType.Delim,"."););return this.finish(e)}return this.accept(r.TokenType.Ident)?this.finish(e):null},e.prototype._parseFunctionArgument=function(){var e=this.create(o.FunctionArgument);return e.setValue(this._parseExpr(!0))?this.finish(e):null},e.prototype._parseHexColor=function(){var e=this.create(o.HexColorValue);return this.accept(r.TokenType.Hash)?this.finish(e):null},e}();t.Parser=u});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/css/common/services/selectorPrinting",["require","exports","vs/languages/css/common/parser/cssNodes","vs/base/common/strings"],function(e,t,n,r){function o(e,t){var o=new c;return e.getChildren().forEach(function(e){switch(e.type){case n.NodeType.SelectorCombinator:if(t){var i=e.getText().split("&");if(1===i.length){o.name=i[0];break}if(o=t.cloneWithParent(),i[0]){var s=o.findRoot();s.name=i[0]+s.name}for(var a=1;a<i.length;a++){if(a>1){var u=t.cloneWithParent();o.addChild(u.findRoot()),o=u}o.name+=i[a]}}break;case n.NodeType.SelectorPlaceholder:case n.NodeType.ElementNameSelector:var c=e.getText();o.name="*"===c?"element":c;break;case n.NodeType.ClassSelector:o.addAttr("class",e.getText().substring(1));break;case n.NodeType.IdentifierSelector:o.addAttr("id",e.getText().substring(1));break;case n.NodeType.MixinDeclaration:o.addAttr("class",e.getName());break;case n.NodeType.PseudoSelector:o.addAttr(e.getText(),r.empty);break;case n.NodeType.AttributeSelector:var l=e.getChildren()[0];if(l&&l.getRight()){var p;switch(l.getOperator().getText()){case"|=":p=r.format("{0}-…",h.remove(l.getRight().getText()));break;case"^=":p=r.format("{0}…",h.remove(l.getRight().getText()));break;case"$=":p=r.format("…{0}",h.remove(l.getRight().getText()));break;case"~=":p=r.format(" … {0} … ",h.remove(l.getRight().getText()));break;case"*=":p=r.format("…{0}…",h.remove(l.getRight().getText()));break;default:p=h.remove(l.getRight().getText())}}o.addAttr(l.getLeft().getText(),p)}}),o}function i(e){var t=o(e),n=new d('"').print(t);return{tagName:"span",className:"selector",children:n}}function s(e){switch(e.type){case n.NodeType.MixinDeclaration:case n.NodeType.Stylesheet:return!0}return!1}function a(e){var t=new l,r=[];if(e.getParent()instanceof n.RuleSet)for(var o=e.getParent().getParent();o&&!s(o);)o instanceof n.RuleSet&&r.push(o),o=o.getParent();for(var i=new f(t),a=r.length-1;a>=0;a--){var u=r[a].getSelectors().getChild(0);u&&i.processSelector(u)}return i.processSelector(e),t}function u(e){var t=a(e),n=new d('"').print(t);return{tagName:"span",className:"selector",children:n}}var c=function(){function e(){}return e.prototype.addChild=function(t){t instanceof e&&(t.parent=this),this.children||(this.children=[]),this.children.push(t)},e.prototype.findRoot=function(){for(var e=this;e.parent&&!(e.parent instanceof l);)e=e.parent;return e},e.prototype.removeChild=function(e){if(this.children){var t=this.children.indexOf(e);if(-1!==t)return this.children.splice(t,1),!0}return!1},e.prototype.addAttr=function(e,t){this.attributes||(this.attributes={}),this.attributes.hasOwnProperty(e)?this.attributes[e]+=" "+t:this.attributes[e]=t},e.prototype.clone=function(t){void 0===t&&(t=!0);var n=new e;if(n.name=this.name,this.attributes){n.attributes={};for(var r in this.attributes)n.addAttr(r,this.attributes[r])}if(t&&this.children){n.children=[];for(var o=0;o<this.children.length;o++)n.addChild(this.children[o].clone())}return n},e.prototype.cloneWithParent=function(){var e=this.clone(!1);if(this.parent&&!(this.parent instanceof l)){var t=this.parent.cloneWithParent();t.addChild(e)}return e},e}();t.Element=c;var l=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t}(c);t.RootElement=l;var p=function(e){function t(t){e.call(this),this.name=t}return __extends(t,e),t}(c);t.LabelElement=p;var h,d=function(){function e(e){this.quote=e}return e.prototype.print=function(e){return e instanceof l?this.doPrint(e.children):this.doPrint([e])},e.prototype.doPrint=function(e){for(var t={children:[]},n=t;e.length>0;){var r=e.shift(),o=this.doPrintElement(r);n.children.push(o),r.children&&(e.push.apply(e,r.children),n=o)}return t.children},e.prototype.doPrintElement=function(e){var t=this;if(e instanceof p)return{tagName:"ul",children:[{tagName:"li",children:[{tagName:"span",className:"label",text:e.name}]}]};var n=[{isText:!0,text:"<"}];return e.name?n.push({tagName:"span",className:"name",text:e.name}):n.push({tagName:"span",text:"element"}),e.attributes&&Object.keys(e.attributes).forEach(function(r){n.push({isText:!0,text:" "}),n.push({tagName:"span",className:"key",text:r});var o=e.attributes[r];o&&(n.push({isText:!0,text:"="}),n.push({tagName:"span",className:"value",text:h.ensure(o,t.quote)}))}),n.push({isText:!0,text:">"}),{tagName:"ul",children:[{tagName:"li",children:n}]}},e}();!function(e){function t(e,t){return t+n(e)+t}function n(e){return e=r.trim(e,"'"),e=r.trim(e,'"')}e.ensure=t,e.remove=n}(h||(h={})),t.toElement=o,t.simpleSelectorToHtml=i;var f=function(){function e(e){this.prev=null,this.element=e}return e.prototype.processSelector=function(e){var t=this,r=null;if(!(this.element instanceof l)&&e.getChildren().some(function(e){return e.hasChildren()&&e.getChild(0).type===n.NodeType.SelectorCombinator})){var i=this.element.findRoot();i.parent instanceof l&&(r=this.element,this.element=i.parent,this.element.removeChild(i),this.prev=null)}e.getChildren().forEach(function(e){if(e instanceof n.SimpleSelector){if(t.prev instanceof n.SimpleSelector){var i=new p("…");t.element.addChild(i),t.element=i}else t.prev&&(t.prev.matches("+")||t.prev.matches("~"))&&(t.element=t.element.parent);t.prev&&t.prev.matches("~")&&(t.element.addChild(o(e)),t.element.addChild(new p("⋮")));var s=o(e,r),a=s.findRoot();t.element.addChild(a),t.element=s}(e instanceof n.SimpleSelector||e.type===n.NodeType.SelectorCombinatorParent||e.type===n.NodeType.SelectorCombinatorSibling||e.type===n.NodeType.SelectorCombinatorAllSiblings)&&(t.prev=e)})},e}();t.selectorToElement=a,t.selectorToHtml=u}),define("vs/languages/css/common/services/lintRules",["require","exports","vs/nls!vs/languages/css/common/cssWorker","vs/languages/css/common/level"],function(e,t,n,r){function o(e){var n={};for(var r in t.Rules){var o=t.Rules[r];n[e+"."+o.id]=o.getConfiguration()}return n}function i(e){var n={};for(var o in t.Rules){var i=t.Rules[o],s=r.toLevel(e[i.id]);s&&(n[i.id]=s)}return n}var s="warning",a="error",u="ignore",c=function(){function e(e,t,n){this.id=e,this.message=t,this.defaultValue=n}return e.prototype.getConfiguration=function(){return{type:"string",enum:[u,s,a],default:this.defaultValue,description:this.message}},e}();t.Rule=c,t.Rules={AllVendorPrefixes:new c("compatibleVendorPrefixes",n.localize("vs_languages_css_common_services_lintRules",0),u),IncludeStandardPropertyWhenUsingVendorPrefix:new c("vendorPrefix",n.localize("vs_languages_css_common_services_lintRules",1),s),DuplicateDeclarations:new c("duplicateProperties",n.localize("vs_languages_css_common_services_lintRules",2),u),EmptyRuleSet:new c("emptyRules",n.localize("vs_languages_css_common_services_lintRules",3),s),ImportStatemement:new c("importStatement",n.localize("vs_languages_css_common_services_lintRules",4),u),NoWidthOrHeightWhenPaddingOrBorder:new c("boxModel",n.localize("vs_languages_css_common_services_lintRules",5),u),UniversalSelector:new c("universalSelector",n.localize("vs_languages_css_common_services_lintRules",6),u),ZeroWithUnit:new c("zeroUnits",n.localize("vs_languages_css_common_services_lintRules",7),u),RequiredPropertiesForFontFace:new c("fontFaceProperties",n.localize("vs_languages_css_common_services_lintRules",8),s),HexColorLength:new c("hexColorLength",n.localize("vs_languages_css_common_services_lintRules",9),a),ArgsInColorFunction:new c("argumentsInColorFunction",n.localize("vs_languages_css_common_services_lintRules",10),a),UnknownProperty:new c("unknownProperties",n.localize("vs_languages_css_common_services_lintRules",11),s),IEStarHack:new c("ieHack",n.localize("vs_languages_css_common_services_lintRules",12),u),UnknownVendorSpecificProperty:new c("unknownVendorSpecificProperties",n.localize("vs_languages_css_common_services_lintRules",13),u),PropertyIgnoredDueToDisplay:new c("propertyIgnoredDueToDisplay",n.localize("vs_languages_css_common_services_lintRules",14),s),AvoidImportant:new c("important",n.localize("vs_languages_css_common_services_lintRules",15),u),AvoidFloat:new c("float",n.localize("vs_languages_css_common_services_lintRules",16),u),AvoidIdSelector:new c("idSelector",n.localize("vs_languages_css_common_services_lintRules",17),u)},t.getConfigurationProperties=o,t.sanitize=i}),define("vs/languages/css/common/services/lint",["require","exports","vs/languages/css/common/services/languageFacts","vs/languages/css/common/services/lintRules","vs/languages/css/common/parser/cssNodes","vs/nls!vs/languages/css/common/cssWorker","vs/languages/css/common/level"],function(e,t,n,r,o,i,s){var a=function(){function e(e,t){this.name=e,this.node=t}return e}(),u=function(){function e(){this.data={}}return e.prototype.add=function(e,t,n){var r=this.data[e];r||(r={nodes:[],names:[]},this.data[e]=r),r.names.push(t),n&&r.nodes.push(n)},e}(),c=function(){function e(e){void 0===e&&(e={}),this.warnings=[],this.configuration={};for(var t in r.Rules){var n=r.Rules[t],o=e[n.id]||s.toLevel(n.defaultValue);this.configuration[n.id]=o}}return e.entries=function(t,n){var r=new e(n);return t.accept(r),r.getEntries()},e.prototype.fetch=function(e,t){for(var n=[],r=0;r<e.length;r++)e[r].name.toLowerCase()===t&&n.push(e[r]);return n},e.prototype.fetchWithValue=function(e,t,n){for(var r=[],o=0;o<e.length;o++)if(e[o].name.toLowerCase()===t){var i=e[o].node.getValue();i&&this.findValueInExpression(i,n)&&r.push(e[o])}return r},e.prototype.findValueInExpression=function(e,t){var n=!1;return e.accept(function(e){return e.type===o.NodeType.Identifier&&e.getText()===t&&(n=!0),!n}),n},e.prototype.fetchWithin=function(e,t){for(var n=[],r=0;r<e.length;r++)e[r].name.toLowerCase().indexOf(t)>=0&&n.push(e[r]);return n},e.prototype.getEntries=function(e){return void 0===e&&(e=s.Level.Warning|s.Level.Error),this.warnings.filter(function(t){return 0!==(t.getLevel()&e)})},e.prototype.addEntry=function(e,t,n){var r=new o.Marker(e,t,this.configuration[t.id],n);this.warnings.push(r)},e.prototype.getMissingNames=function(e,t){e=e.slice(0);for(var n=0;n<t.length;n++){var r=e.indexOf(t[n]);-1!==r&&(e[r]=null)}for(var o=null,n=0;n<e.length;n++){var s=e[n];s&&(o=null===o?i.localize("vs_languages_css_common_services_lint",0,s):i.localize("vs_languages_css_common_services_lint",1,o,s))}return o},e.prototype.visitNode=function(e){switch(e.type){case o.NodeType.Stylesheet:return this.visitStylesheet(e);case o.NodeType.FontFace:return this.visitFontFace(e);case o.NodeType.Ruleset:return this.visitRuleSet(e);case o.NodeType.SimpleSelector:return this.visitSimpleSelector(e);case o.NodeType.Function:return this.visitFunction(e);case o.NodeType.NumericValue:return this.visitNumericValue(e);case o.NodeType.Import:return this.visitImport(e)}return this.visitUnknownNode(e)},e.prototype.visitStylesheet=function(e){var t=this,n=new u;e.accept(function(e){if(e instanceof o.Keyframe){var t=e.getKeyword(),r=t.getText();n.add(e.getName(),r,"@keyframes"!==r?t:null)}return!0});var s=["@-webkit-keyframes","@-moz-keyframes","@-o-keyframes"],a=function(e){if(p){var n=i.localize("vs_languages_css_common_services_lint",2);t.addEntry(e,r.Rules.IncludeStandardPropertyWhenUsingVendorPrefix,n)}if(h){var n=i.localize("vs_languages_css_common_services_lint",3,h);t.addEntry(e,r.Rules.AllVendorPrefixes,n)}};for(var c in n.data){var l=n.data[c].names,p=-1===l.indexOf("@keyframes");if(p||1!==l.length){var h=this.getMissingNames(s,l);(h||p)&&n.data[c].nodes.forEach(a)}}return!0},e.prototype.visitSimpleSelector=function(e){var t=e.getText();return"*"===t&&this.addEntry(e,r.Rules.UniversalSelector),0===t.indexOf("#")&&this.addEntry(e,r.Rules.AvoidIdSelector),!0},e.prototype.visitImport=function(e){return this.addEntry(e,r.Rules.ImportStatemement),!0},e.prototype.visitRuleSet=function(t){var s=this,c=t.getDeclarations();if(!c)return!1;c.hasChildren()||this.addEntry(t.getSelectors(),r.Rules.EmptyRuleSet);var l=this,p=[];if(c.getChildren().forEach(function(e){if(e instanceof o.Declaration){var t=e;p.push(new a(t.getFullPropertyName(),t))}},this),(this.fetch(p,"width").length>0||this.fetch(p,"height").length>0)&&(this.fetchWithin(p,"padding").length>0||this.fetchWithin(p,"border").length>0)){for(var h=this.fetch(p,"width"),d=0;d<h.length;d++)this.addEntry(h[d].node,r.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetch(p,"height");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,r.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetchWithin(p,"padding");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,r.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetchWithin(p,"border");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,r.Rules.NoWidthOrHeightWhenPaddingOrBorder)}var f=this.fetchWithValue(p,"display","inline");f.length>0&&["width","height","margin-top","margin-bottom","float"].forEach(function(e){for(var t=l.fetch(p,e),n=0;n<t.length;n++)l.addEntry(t[n].node,r.Rules.PropertyIgnoredDueToDisplay)});var f=this.fetchWithValue(p,"display","inline-block");if(f.length>0)for(var m=this.fetch(p,"float"),d=0;d<m.length;d++)this.addEntry(m[d].node,r.Rules.PropertyIgnoredDueToDisplay);var f=this.fetchWithValue(p,"display","block");if(f.length>0)for(var m=this.fetch(p,"vertical-align"),d=0;d<m.length;d++)this.addEntry(m[d].node,r.Rules.PropertyIgnoredDueToDisplay);t.accept(function(e){return e.type===o.NodeType.Prio&&l.addEntry(e,r.Rules.AvoidImportant),!0});for(var h=this.fetch(p,"float"),d=0;d<h.length;d++)this.addEntry(h[d].node,r.Rules.AvoidFloat);for(var g=0;g<p.length;g++){var v=p[g];if("background"!==v.name.toLowerCase()){var y=v.node.getValue();if(y&&"-"!==y.getText()[0]){var h=this.fetch(p,v.name);if(h.length>1)for(var _=0;_<h.length;_++){var y=h[_].node.getValue();y&&"-"!==y.getText()[0]&&h[_]!==v&&this.addEntry(v.node,r.Rules.DuplicateDeclarations)}}}}var b=new u,S=!1;if(c.getChildren().forEach(function(e){if(s.isCSSDeclaration(e)){var t=e,o=t.getFullPropertyName(),i=o.charAt(0);if("-"===i){n.isKnownProperty(o)||s.addEntry(t.getProperty(),r.Rules.UnknownVendorSpecificProperty);var a=t.getNonPrefixedPropertyName();b.add(a,o,t.getProperty())}else("*"===i||"_"===i)&&(s.addEntry(t.getProperty(),r.Rules.IEStarHack),o=o.substr(1)),n.isKnownProperty(o)||s.addEntry(t.getProperty(),r.Rules.UnknownProperty),b.add(o,o,null)}else S=!0}),!S){var k=function(e){if(x){var t=i.localize("vs_languages_css_common_services_lint",4,C);s.addEntry(e,r.Rules.IncludeStandardPropertyWhenUsingVendorPrefix,t)}if(I){var t=i.localize("vs_languages_css_common_services_lint",5,I);s.addEntry(e,r.Rules.AllVendorPrefixes,t)}};for(var C in b.data){var T=b.data[C],E=T.names,x=n.isKnownProperty(C)&&-1===E.indexOf(C);if(x||1!==E.length){for(var w=[],g=0,M=e.prefixes.length;M>g;g++){var L=e.prefixes[g];n.isKnownProperty(L+C)&&w.push(L+C)}var I=this.getMissingNames(w,E);(I||x)&&T.nodes.forEach(k)}}}return!0},e.prototype.visitNumericValue=function(e){var t=e.getValue();return"%"===t.unit?!0:(0===parseFloat(t.value)&&t.unit&&this.addEntry(e,r.Rules.ZeroWithUnit),!0)},e.prototype.visitFontFace=function(e){var t=this,n=e.getDeclarations();if(n){var o=!1,i=!1,s=!1;return n.getChildren().forEach(function(e){if(t.isCSSDeclaration(e)){var n=e.getProperty().getName().toLocaleLowerCase();
"src"===n&&(o=!0),"font-family"===n&&(i=!0)}else s=!0}),s||o&&i||this.addEntry(e,r.Rules.RequiredPropertiesForFontFace),!0}},e.prototype.isCSSDeclaration=function(e){if(e instanceof o.Declaration){if(!e.getValue())return!1;var t=e.getProperty();return!t||t.getIdentifier().containsInterpolation()?!1:!0}return!1},e.prototype.visitUnknownNode=function(e){if(e.type===o.NodeType.HexColorValue){var t=e.getText();7!==t.length&&4!==t.length&&this.addEntry(e,r.Rules.HexColorLength)}return!0},e.prototype.visitFunction=function(e){var t=e.getName().toLowerCase(),n=-1,i=0;switch(t){case"rgb(":case"hsl(":n=3;break;case"rgba(":case"hsla(":n=4}return-1!==n&&(e.getArguments().accept(function(e){return e instanceof o.BinaryExpression?(i+=1,!1):!0}),i!==n&&this.addEntry(e,r.Rules.ArgsInColorFunction)),!0},e.prefixes=["-ms-","-moz-","-o-","-webkit-"],e}();t.LintVisitor=c});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/css/common/cssWorker",["require","exports","vs/nls!vs/languages/css/common/cssWorker","vs/base/common/severity","vs/base/common/strings","vs/base/common/winjs.base","vs/editor/common/modes/abstractModeWorker","vs/languages/css/common/services/cssLanguageService","vs/languages/css/common/services/languageFacts","./services/occurrences","vs/languages/css/common/services/intelliSense","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/level","vs/languages/css/common/parser/cssParser","vs/languages/css/common/services/selectorPrinting","vs/languages/css/common/services/lint","vs/languages/css/common/services/lintRules","vs/editor/common/modes/supports"],function(e,t,n,r,o,i,s,a,u,c,l,p,h,d,f,m,g,v){var y=function(e){function t(t,n,r){e.call(this,t,n,r),this.languageService=this.createLanguageService(t,n.getId()),this.lintSettings={}}return __extends(t,e),t.prototype._createInPlaceReplaceSupport=function(){return new v.WorkerInplaceReplaceSupport(this.resourceService,this)},t.prototype.createLanguageService=function(e,t){return new a.CSSLanguageService(e.resourceService,this.createParser.bind(this),t)},t.prototype.createParser=function(){return new d.Parser},t.prototype._doConfigure=function(e){return e?(this.lintSettings=e.lint?g.sanitize(e.lint):{},i.TPromise.as(!0)):i.TPromise.as(!1)},t.prototype.doValidate=function(e){var t=this;this.languageService.join().then(function(){var n=t.resourceService.get(e),r=t.languageService.getStylesheet(e),o=[];o.push.apply(o,p.ParseErrorCollector.entries(r)),o.push.apply(o,t.collectLintEntries(r));var i=o.filter(function(e){return e.getLevel()!==h.Level.Ignore}).map(function(e){return t._createMarkerData(n,e)});t.markerService.changeOne(t._getMode().getId(),e,i)})},t.prototype._createMarkerData=function(e,t){var n=e.getRangeFromOffsetAndLength(t.getOffset(),t.getLength());return{code:t.getRule().id,message:t.getMessage(),severity:t.getLevel()===h.Level.Warning?r.Warning:r.Error,startLineNumber:n.startLineNumber,startColumn:n.startColumn,endLineNumber:n.endLineNumber,endColumn:n.endColumn}},t.prototype.collectLintEntries=function(e){return m.LintVisitor.entries(e,this.lintSettings)},t.prototype.createIntellisense=function(){return new l.CSSIntellisense},t.prototype.doSuggest=function(e,t){var n=this;return this.languageService.join().then(function(){var r=n.resourceService.get(e),o=n.createIntellisense().getCompletionsAtPosition(n.languageService,r,e,t);return o})},t.prototype.getRangesToPosition=function(e,t){var n=this;return this.languageService.join().then(function(){for(var r=n.resourceService.get(e),o=r.getOffsetFromPosition(t),i=n.languageService.getStylesheet(e),s=p.getNodePath(i,o),a=[],u=0;u<s.length;u++){var c=s[u];-1!==c.offset&&-1!==c.length&&(c.parent&&c.parent.offset===c.offset&&c.parent.length===c.length||a.push({type:"node",range:n._range(c,r)}))}return a})},t.prototype.getOutline=function(e){var t=this;return this.languageService.join().then(function(){var r=t.resourceService.get(e),o=t.languageService.getStylesheet(e),i=[];return o.accept(function(e){var o={label:null,type:"rule",range:null,children:[]};return e instanceof p.Selector?o.label=e.getText():e instanceof p.VariableDeclaration?(o.label=e.getName(),o.type="variable"):e instanceof p.MixinDeclaration?(o.label=e.getName(),o.type="method"):e instanceof p.FunctionDeclaration?(o.label=e.getName(),o.type="function"):e instanceof p.Keyframe?o.label=n.localize("vs_languages_css_common_cssWorker",0,e.getName()):e instanceof p.FontFace&&(o.label=n.localize("vs_languages_css_common_cssWorker",1)),o.label&&(o.range=t._range(e,r,!0),i.push(o)),!0}),i})},t.prototype.computeInfo=function(e,t){var n=this;return this.languageService.join().then(function(){for(var r=n.resourceService.get(e),o=r.getOffsetFromPosition(t),i=n.languageService.getStylesheet(e),s=p.getNodePath(i,o),a=0;a<s.length;a++){var u=s[a];if(u instanceof p.Selector)return{htmlContent:[f.selectorToHtml(u)],range:n._range(u,r)};if(u instanceof p.SimpleSelector)return{htmlContent:[f.simpleSelectorToHtml(u)],range:n._range(u,r)}}return null})},t.prototype.findDeclaration=function(e,t){var n=this;return this.languageService.join().then(function(){var r=n.resourceService.get(e),o=r.getOffsetFromPosition(t),i=c.findDeclaration(n.languageService.getStylesheet(e),o);return i?{resourceUrl:e,range:n._range(i,r,!0)}:null})},t.prototype.findOccurrences=function(e,t){var n=this;return this.languageService.join().then(function(){var r=n.resourceService.get(e),o=r.getOffsetFromPosition(t),i=c.findOccurrences(n.languageService.getStylesheet(e),o);return i.map(function(e){return{range:n._range(e.node,r),kind:e.kind}})})},t.prototype.findReferences=function(e,t){var n=this;return this.languageService.join().then(function(){var r=n.resourceService.get(e),o=r.getOffsetFromPosition(t),i=c.findOccurrences(n.languageService.getStylesheet(e),o);return i.map(function(e){return{resourceUrl:r.getAssociatedResource(),range:n._range(e.node,r)}})})},t.prototype.navigateValueSetFallback=function(e,t,n){var r=this;return this.languageService.join().then(function(){var i=r.resourceService.get(e),s=i.getOffsetFromPosition({lineNumber:t.startLineNumber,column:t.startColumn}),a=r.languageService.getStylesheet(e),c=p.getNodeAtOffset(a,s);if(c){var l=p.getParentDeclaration(c);if(l){var h=u.getProperties()[l.getFullPropertyName()];if(h&&h.values){var d=h.values.filter(function(e){return u.isCommonValue(e)}).map(function(e){return e.name}),f=h.restrictions.indexOf("color")>=0;f&&(d=d.concat(Object.getOwnPropertyNames(u.colors),Object.getOwnPropertyNames(u.colorKeywords)));for(var m=c.getText(),g=0,v=d.length;v>g;g++)if(o.equalsIgnoreCase(d[g],m)){var y=g;n?y=(g+1)%v:(y=g-1,0>y&&(y=v-1));var _={value:d[y],range:r._range(c,i)};return _}if(d.length>0){var _={value:d[0],range:r._range(c,i)};return _}return null}}}})},t.prototype.findColorDeclarations=function(e){var t=this;return this.languageService.join().then(function(){var n=t.resourceService.get(e),r=t.languageService.getStylesheet(e),o=[];return r.accept(function(e){return u.isColorValue(e)&&o.push({range:t._range(e,n),value:e.getText()}),!0}),o})},t.prototype._range=function(e,t,n){if(void 0===n&&(n=!1),n){var r=t.getPositionFromOffset(e.offset);return{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:r.lineNumber,endColumn:r.column}}return t.getRangeFromOffsetAndLength(e.offset,e.length)},t.prototype.getFixesForUnknownProperty=function(e){var t=e.getName(),r=[];for(var i in u.getProperties()){var s=o.difference(t,i);s>=t.length/2&&r.push({label:n.localize("vs_languages_css_common_cssWorker",2,i),id:JSON.stringify({type:"rename",name:i}),score:s})}return r.sort(function(e,t){return t.score-e.score}),r.slice(0,3)},t.prototype.getQuickFixes=function(e,t){var n=this;return t.code!==g.Rules.UnknownProperty.id?i.TPromise.as([]):this.languageService.join().then(function(){for(var r=n.resourceService.get(e),o=r.getOffsetFromPosition({column:t.startColumn,lineNumber:t.startLineNumber}),i=n.languageService.getStylesheet(e),s=p.getNodePath(i,o),a=s.length-1;a>=0;a--){var u=s[a];if(u instanceof p.Declaration){var c=u.getProperty();if(c&&c.offset===o&&c.length===t.endColumn-t.startColumn)return n.getFixesForUnknownProperty(c)}}return[]})},t.prototype.runQuickFixAction=function(e,t,n){var r=JSON.parse(n);switch(r.type){case"rename":return i.TPromise.as({edits:[{resource:e,range:t,newText:r.name}]})}return null},t}(s.AbstractModeWorker);t.CSSWorker=y});