/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/features/tokenization",["require","exports","vs/base/common/strings","vs/base/common/arrays","vs/base/common/collections","vs/editor/common/modes","vs/editor/common/modes/supports","vs/languages/vsxml/common/vsxml","vs/editor/common/modes/lineStream","vs/languages/typescript/common/lib/typescriptServices","vs/editor/common/modes/abstractState"],function(e,t,n,r,i,a,o,s,c,l,u){function d(e,t){var n=l.createClassifier(),r=t===f.TypeScript?v:b,i=t===f.TypeScript?_:T;return{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new g(e,null,t,0,!1)},tokenize:function(e,t,a,o){return p(r,i,n,t,e,a,o)}}}function p(e,t,i,s,c,u){function d(e,t,n){(0===p.tokens.length||void 0!==n||r.tail(p.tokens).type!==t)&&p.tokens.push(new o.Token(e,t,n||a.Bracket.None))}void 0===u&&(u=0);var p={tokens:[],actualStopOffset:u+c.length,endState:new g(s.getMode(),s.getStateData(),s.language,0,!1),modeTransitions:[{startIndex:u,mode:s.getMode()}]};if(0===s.eolState&&h(s,u,c,d))return p;var v=s.language===f.TypeScript;if(!v&&m(s,u,c,d))return p;var _=i.getClassificationsForLine(c,s.eolState,!0),b=0;p.endState.eolState=_.finalLexState,p.endState.inJsDocComment=1===_.finalLexState&&(s.inJsDocComment||/\/\*\*.*$/.test(c));for(var T=0,E=_.entries;T<E.length;T++){var S,k=E[T],C=a.Bracket.None;if(k.classification===l.TokenClass.Punctuation){var x=c.charCodeAt(b);C=y[x]||a.Bracket.None,S=e[x]||t[k.classification],d(b+u,S,C)}else k.classification===l.TokenClass.Comment?p.endState.inJsDocComment||/\/\*\*.*\*\//.test(c.substr(b,k.length))?d(b+u,v?"comment.doc.ts":"comment.doc.js",a.Bracket.None):d(b+u,v?"comment.ts":"comment.js",a.Bracket.None):d(b+u,t[k.classification]||n.empty,void 0);b+=k.length}return p}function m(e,t,n,r){return 0===n.indexOf("#!")?(r(t,"comment.shebang",a.Bracket.None),!0):void 0}function h(e,t,n,r){if(!n.match(E))return!1;var i,o,l=new c.LineStream(n),u=new s.VSXMLExpression(e.getMode(),e);for(l.advanceIfRegExp(E).length>0&&r(t,"comment.vs",a.Bracket.None);!l.eos();){o=l.pos();do{if(i=u.tokenize(l),null===i||void 0===i||(void 0===i.type||null===i.type)&&(void 0===i.nextState||null===i.nextState))throw new Error("Tokenizer must return a valid state");if(i.nextState&&(i.nextState.setStateData(u.getStateData()),u=i.nextState),l.pos()<=o)throw new Error}while(!i.type&&""!==i.type);r(o+t,i.type,i.bracket)}return!0}!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(t.Language||(t.Language={}));var f=t.Language;t.createTokenizationSupport=d;var g=function(){function e(e,t,n,r,i){this._mode=e,this._state=t,this.language=n,this.eolState=r,this.inJsDocComment=i}return e.prototype.clone=function(){return new e(this._mode,u.AbstractState.safeClone(this._state),this.language,this.eolState,this.inJsDocComment)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.eolState!==t.eolState?!1:this.inJsDocComment!==t.inJsDocComment?!1:u.AbstractState.safeEquals(this._state,t._state):!1},e.prototype.getMode=function(){return this._mode},e.prototype.tokenize=function(){throw new Error},e.prototype.getStateData=function(){return this._state},e.prototype.setStateData=function(e){this._state=e},e}(),y=i.createNumberDictionary();y["(".charCodeAt(0)]=a.Bracket.Open,y[")".charCodeAt(0)]=a.Bracket.Close,y["{".charCodeAt(0)]=a.Bracket.Open,y["}".charCodeAt(0)]=a.Bracket.Close,y["[".charCodeAt(0)]=a.Bracket.Open,y["]".charCodeAt(0)]=a.Bracket.Close;var v=i.createNumberDictionary();v["(".charCodeAt(0)]="delimiter.parenthesis.ts",v[")".charCodeAt(0)]="delimiter.parenthesis.ts",v["{".charCodeAt(0)]="delimiter.bracket.ts",v["}".charCodeAt(0)]="delimiter.bracket.ts",v["[".charCodeAt(0)]="delimiter.array.ts",v["]".charCodeAt(0)]="delimiter.array.ts";var _=i.createNumberDictionary();_[l.TokenClass.Identifier]="identifier.ts",_[l.TokenClass.Keyword]="keyword.ts",_[l.TokenClass.Operator]="delimiter.ts",_[l.TokenClass.Punctuation]="delimiter.ts",_[l.TokenClass.NumberLiteral]="number.ts",_[l.TokenClass.RegExpLiteral]="regexp.ts",_[l.TokenClass.StringLiteral]="string.ts";var b=i.createNumberDictionary();b["(".charCodeAt(0)]="delimiter.parenthesis.js",b[")".charCodeAt(0)]="delimiter.parenthesis.js",b["{".charCodeAt(0)]="delimiter.bracket.js",b["}".charCodeAt(0)]="delimiter.bracket.js",b["[".charCodeAt(0)]="delimiter.array.js",b["]".charCodeAt(0)]="delimiter.array.js";var T=i.createNumberDictionary();T[l.TokenClass.Identifier]="identifier.js",T[l.TokenClass.Keyword]="keyword.js",T[l.TokenClass.Operator]="delimiter.js",T[l.TokenClass.Punctuation]="delimiter.js",T[l.TokenClass.NumberLiteral]="number.js",T[l.TokenClass.RegExpLiteral]="regexp.js",T[l.TokenClass.StringLiteral]="string.js";var E=/^\s*\/\/\//}),define("vs/platform/request/common/request",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IRequestService=n.createDecorator("requestService")}),define("vs/platform/workspace/common/workspace",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IWorkspaceContextService=n.createDecorator("contextService")});var __decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/typescript/common/features/quickFixMainActions",["require","exports","vs/nls!vs/languages/typescript/common/typescriptMode","vs/base/common/winjs.base","vs/platform/files/common/files","vs/platform/request/common/request","vs/platform/workspace/common/workspace"],function(e,t,n,r,i,a,o){var s=function(){function e(e,t,n){this._requestService=e,this._fileService=t,this._contextService=n}return e.prototype.evaluate=function(e,t,n){var i=JSON.parse(n);switch(i.type){case"typedefinitions":return this.evaluateAddTypeDefinitionProposal(i.name,e)}return r.Promise.as(null)},e.prototype.evaluateAddTypeDefinitionProposal=function(e){var t=this,r="/typings/"+e,i="/jsconfig.json";return this._fileService.resolveFileStat(r).then(function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",0,r)}},function(){var a="https://raw.githubusercontent.com/borisyankov/DefinitelyTyped/master/"+e;return t._requestService.makeRequest({url:a,followRedirects:5}).then(function(e){return t._fileService.createFile(r,e.responseText).then(function(){return t._fileService.resolveFileStat(i).then(function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",1,r)}},function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",2,r)}})},function(e){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",3,r,e.toString())}})},function(e){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",4,a,e.toString())}})})},e=__decorate([__param(0,a.IRequestService),__param(1,i.IFileService),__param(2,o.IWorkspaceContextService)],e)}();t.QuickFixMainActions=s}),define("vs/languages/typescript/common/typescript",["require","exports","vs/platform/platform","vs/base/common/uri"],function(e,t,n,r){function i(){return{resolveProjects:function(){return void 0},resolveFiles:function(){return void 0}}}function a(e){return"string"==typeof e?0===e.indexOf("ts://defaultlib"):"ts"===e.scheme&&"defaultlib"===e.authority}!function(e){e[e.Changed=0]="Changed",e[e.Added=1]="Added",e[e.Removed=2]="Removed"}(t.ChangeKind||(t.ChangeKind={}));t.ChangeKind;t.createDefaultProjectResolver=i,t.defaultLib=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.d.ts"),t.defaultLibES6=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.es6.d.ts"),t.isDefaultLib=a,t.virtualProjectResource=r.create("ts","projects","/virtual/1");var o;!function(e){function t(e){i=e}function r(){return i}e.Identifier="typescript",n.Registry.add(e.Identifier,e);var i;e.setProjectResolver=t,e.getProjectResolver=r}(o=t.Extensions||(t.Extensions={}))});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/typescript/common/typescriptMode",["require","exports","vs/nls!vs/languages/typescript/common/typescriptMode","vs/base/common/winjs.base","vs/base/common/uri","vs/editor/common/common","vs/base/common/lifecycle","vs/base/common/async","vs/editor/common/modes/supports","vs/languages/typescript/common/features/tokenization","vs/languages/typescript/common/features/quickFixMainActions","vs/languages/typescript/common/typescript","vs/editor/common/modes/abstractMode","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors","vs/platform/thread/common/thread"],function(e,t,n,r,i,a,o,s,c,l,u,d,p,m,h,f){var g=function(){function e(e,t){this._listener=Object.create(null),this._lastValidationReq=0,this._modelService=e.modelService,this._mode=t,this._validation=new s.RunOnceScheduler(this._doValidate.bind(this),750),this._modelService?(this._modelService.onModelAdded.add(this._onModelAdded,this),this._modelService.onModelRemoved.add(this._onModelRemoved,this),this._modelService.getModels().forEach(this._onModelAdded,this)):console.warn("NO model service for validation")}return e.prototype.dispose=function(){this._validation.dispose()},e.prototype.validateOpen=function(){this._scheduleValidation()},e.prototype._scheduleValidation=function(e){this._lastValidationReq+=1,this._lastChangedResource=e,this._validation.schedule()},e.prototype._doValidate=function(){var e=this,t=[];this._lastChangedResource&&t.push(this._lastChangedResource);for(var n in this._listener)this._lastChangedResource&&n===this._lastChangedResource.toString()||t.push(i.parse(n));var a=this._lastValidationReq,o=s.sequence(t.map(function(t){return function(){return e._modelService.getModel(t)?a===e._lastValidationReq?e._mode.performSemanticValidation(t):void 0:r.Promise.as(void 0)}}));o.done(void 0,function(e){return console.warn(e)})},e.prototype._onModelAdded=function(e){var t=this;if(this._mode._shouldBeValidated(e)){var n,r;n=function(){t._scheduleValidation(e.getAssociatedResource())},r=e.addListener(a.EventType.ModelContentChanged2,function(){return n()}),this._listener[e.getAssociatedResource().toString()]=r,n()}},e.prototype._onModelRemoved=function(e){var t=this._listener[e.getAssociatedResource().toString()];t&&(t(),delete this._listener[e.getAssociatedResource().toString()])},e}(),y=function(t){function i(e,n,i){var a=this;if(t.call(this,e,n,i,h.AsyncDescriptor.create("vs/languages/typescript/common/typescriptWorker2","TypeScriptWorker2")),this._disposables=[],this._telemetryService=e.telemetryService,this._threadService&&this._threadService.isInMainThread){this._semanticValidator=e.instantiationService.createInstance(g,this),this._disposables.push(this._semanticValidator);var o=this._getProjectResolver();this._projectResolver=o?e.instantiationService.createInstance(o,this).then(void 0,function(e){return console.error(e),d.createDefaultProjectResolver()}):r.TPromise.as(d.createDefaultProjectResolver())}this.navigateTypesSupport=this,this.extraInfoSupport=this,this.formattingSupport=this,this.quickFixSupport=this,this.logicalSelectionSupport=this,this.outlineSupport=this,this.emitOutputSupport=this,this.codeLensSupport=this,this.renameSupport=this,this.tokenizationSupport=l.createTokenizationSupport(this,l.Language.TypeScript),this.electricCharacterSupport=new c.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.ts",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.ts",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.ts",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.referenceSupport=new c.ReferenceSupport(this,{tokens:["identifier.ts"],findReferences:function(e,t,n){return a.findReferences(e,t,n)}}),this.declarationSupport=new c.DeclarationSupport(this,{tokens:["identifier.ts","string.ts","attribute.value.vs"],findDeclaration:function(e,t){return a.findDeclaration(e,t)}}),this.parameterHintsSupport=new c.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.ts"],getParameterHints:function(e,t){return a.getParameterHints(e,t)}}),this.characterPairSupport=new c.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`"}]}),this.suggestSupport=new c.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return a.suggest(e,t)},getSuggestionDetails:function(e,t,n){return a.getSuggestionDetails(e,t,n)}})}return __extends(i,t),i.prototype.dispose=function(){this._disposables=o.disposeAll(this._disposables)},i.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.ts$/.test(e.getAssociatedResource().fsPath)},i.prototype._getProjectResolver=function(){return d.Extensions.getProjectResolver()},i.prototype.acceptProjectChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptProjectChanges(e)},i.prototype._doAcceptProjectChanges=function(e){return this._worker(function(t){return t.acceptProjectChanges(e)})},i.prototype.acceptFileChanges=function(e){for(var t=this,i=0,a=0;a<e.length;a++){var o=e[a];o.content&&(i+=o.content.length)}return this._canAcceptFileChanges(i).then(function(i){return i?t._doAcceptFileChanges(e).then(function(e){return t._semanticValidator.validateOpen(),e}):r.TPromise.wrapError(n.localize("vs_languages_typescript_common_typescriptMode",0))})},i.prototype._canAcceptFileChanges=function(e){return this._worker(function(t){return t.canAcceptFileChanges(e)})},i.prototype._doAcceptFileChanges=function(e){return this._worker(function(t){return t.acceptFileChanges(e)})},i.prototype._defaultLib=function(){var t=this;if(!this._defaultLibPromise){var n=[],i=new r.TPromise(function(t,n){return e([d.defaultLib.path.substr(1)],t,n)}).then(function(e){n.push({kind:d.ChangeKind.Added,resource:d.defaultLib,content:e})}),a=new r.TPromise(function(t,n){return e([d.defaultLibES6.path.substr(1)],t,n)}).then(function(e){n.push({kind:d.ChangeKind.Added,resource:d.defaultLibES6,content:e})});this._defaultLibPromise=r.TPromise.join([i,a]).then(function(){return t.acceptFileChanges(n)})}return new s.ShallowCancelThenPromise(this._defaultLibPromise)},i.prototype._syncProjects=function(){var e=this;return this._projectResolver?this._defaultLib().then(function(){return e._projectResolver}).then(function(e){return e.resolveProjects()}):void 0},i.prototype.configure=function(e){var n=this,r=t.prototype.configure.call(this,e);return this._semanticValidator&&r.then(function(e){return e&&n._semanticValidator.validateOpen()}),r},i.prototype._worker=function(e){return t.prototype._worker.call(this,e)},i.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},i.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},i.prototype.performSemanticValidation=function(e){var t=this;return this.doValidateSemantics(e).then(function(e){return e?t.getMissingFiles().then(function(e){return e?t._projectResolver.then(function(t){return t.resolveFiles(e)}):void 0}):void 0})},i.prototype.doValidateSemantics=function(e){return this._worker(function(t){return t.doValidateSemantics(e)})},i.prototype.getMissingFiles=function(){return this._worker(function(e){return e.getMissingFiles()})},i.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},i.prototype.findOccurrences=function(e,t,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(e,t,n)})},i.prototype.suggest=function(e,t){return this._worker(function(n){return n.suggest(e,t)})},i.prototype.getSuggestionDetails=function(e,t,n){return this._worker(function(r){return r.getSuggestionDetails(e,t,n)})},i.prototype.getParameterHints=function(e,t){return this._worker(function(n){return n.getParameterHints(e,t)})},i.prototype.getEmitOutput=function(e,t){return void 0===t&&(t=void 0),this._worker(function(n){return n.getEmitOutput(e,t)})},i.prototype.getWordDefinition=function(){return i.WORD_DEFINITION},i.prototype.findReferences=function(e,t,n){return this._worker(function(r){return r.findReferences(e,t,n)})},Object.defineProperty(i.prototype,"filter",{get:function(){return["identifier.ts","string.ts"]},enumerable:!0,configurable:!0}),i.prototype.rename=function(e,t,n){return this._worker(function(r){return r.rename(e,t,n)})},i.prototype.getNavigateToItems=function(e){return this._worker(function(t){return t.getNavigateToItems(e)})},i.prototype.runQuickFixAction=function(e,t,n){var r=this,i=this._instantiationService.createInstance(u.QuickFixMainActions);return i.evaluate(e,t,n).then(function(i){return i?i:r.runQuickFixActionInWorker(e,t,n)})},i.prototype.runQuickFixActionInWorker=function(e,t,n){return this._worker(function(r){return r.runQuickFixAction(e,t,n)})},i.prototype.getQuickFixes=function(e,t){return this._worker(function(n){return n.getQuickFixes(e,t)})},i.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},i.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},i.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},i.prototype.getAutoFormatTriggerCharacters=function(){return[";","}","\n"]},i.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.formatDocument(e,t)})},i.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.formatRange(e,t,n)})},i.prototype.formatAfterKeystroke=function(e,t,n,r){return this._worker(function(i){return i.formatAfterKeystroke(e,t,n,r)})},i.prototype.enableCodeLens=function(){return this._options&&this._options.referenceInfos===!0},i.prototype.findCodeLensSymbols=function(e){return this._worker(function(t){return t.findCodeLensSymbols(e)})},i.prototype.findCodeLensReferences=function(e,t){return this._worker(function(n){return n.findCodeLensReferences(e,t)})},i.$_doAcceptProjectChanges=m.AllWorkersAttr(i,i.prototype._doAcceptProjectChanges),i.$_canAcceptFileChanges=m.OneWorkerAttr(i,i.prototype._canAcceptFileChanges),i.$_doAcceptFileChanges=m.AllWorkersAttr(i,i.prototype._doAcceptFileChanges),i.$_pickAWorkerToValidate=m.OneWorkerAttr(i,i.prototype._pickAWorkerToValidate,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.$doValidateSemantics=m.OneWorkerAttr(i,i.prototype.doValidateSemantics,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.$getMissingFiles=m.OneWorkerAttr(i,i.prototype.getMissingFiles,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.$getOutline=m.OneWorkerAttr(i,i.prototype.getOutline,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.$findOccurrences=m.OneWorkerAttr(i,i.prototype.findOccurrences,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$suggest=m.OneWorkerAttr(i,i.prototype.suggest,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getSuggestionDetails=m.OneWorkerAttr(i,i.prototype.getSuggestionDetails,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getParameterHints=m.OneWorkerAttr(i,i.prototype.getParameterHints,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getEmitOutput=m.OneWorkerAttr(i,i.prototype.getEmitOutput,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.WORD_DEFINITION=p.createWordRegExp("$"),i.$findReferences=m.OneWorkerAttr(i,i.prototype.findReferences,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.$rename=m.OneWorkerAttr(i,i.prototype.rename,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getNavigateToItems=m.OneWorkerAttr(i,i.prototype.getNavigateToItems,i.prototype._syncProjects,f.ThreadAffinity.Group3),i.$runQuickFixActionInWorker=m.OneWorkerAttr(i,i.prototype.runQuickFixActionInWorker,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getQuickFixes=m.OneWorkerAttr(i,i.prototype.getQuickFixes,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$getRangesToPosition=m.OneWorkerAttr(i,i.prototype.getRangesToPosition,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.$findDeclaration=m.OneWorkerAttr(i,i.prototype.findDeclaration,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$computeInfo=m.OneWorkerAttr(i,i.prototype.computeInfo,i.prototype._syncProjects,f.ThreadAffinity.Group2),i.$formatDocument=m.OneWorkerAttr(i,i.prototype.formatDocument,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.$formatRange=m.OneWorkerAttr(i,i.prototype.formatRange,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.$formatAfterKeystroke=m.OneWorkerAttr(i,i.prototype.formatAfterKeystroke,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.findCodeLensSymbols=m.OneWorkerAttr(i,i.prototype.findCodeLensSymbols,i.prototype._syncProjects,f.ThreadAffinity.Group1),i.findCodeLensReferences=m.OneWorkerAttr(i,i.prototype.findCodeLensReferences,i.prototype._syncProjects,f.ThreadAffinity.Group3),i}(p.AbstractMode);t.TypeScriptMode=y});