/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/parts/debug/browser/debugViewer",["require","exports","vs/base/common/winjs.base","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/errors","vs/base/common/paths","vs/base/common/async","vs/base/common/strings","vs/base/browser/dom","vs/base/common/labels","vs/base/common/events","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/parts/tree/browser/treeDefaults","vs/base/parts/tree/browser/actionsRenderer","vs/workbench/parts/debug/common/debug","vs/workbench/parts/debug/common/debugModel","vs/workbench/parts/debug/common/debugViewModel","vs/workbench/parts/debug/browser/debugActions"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f,g,y,v,_){function b(e,t,n){var r=e.getElementsByClassName(n);if(r.length>0)return r.item(0);var i=document.createElement(t);return n&&l.addClass(i,n),e.appendChild(i),i}t.getOrCreateChild=b;var T=function(e){function t(t,n,r){e.call(this,{actionProvider:n,actionRunner:r}),this.contextService=t}return __extends(t,e),t.prototype.getHeight=function(){return t.ELEMENT_HEIGHT},t.ELEMENT_HEIGHT=24,t}(f.ActionsRenderer);t.AbstractRenderer=T;var E=function(){function e(){}return e.prototype.hasActions=function(){return!1},e.prototype.getActions=function(){var e=[];return n.Promise.as(e)},e.prototype.hasSecondaryActions=function(){return!1},e.prototype.getSecondaryActions=function(){var e=[];return n.Promise.as(e)},e.prototype.getActionItem=function(){return null},e}();t.SimpleActionProvider=E;var S=function(e){function t(t,n,i){e.call(this),this.debugService=t,this.contextMenuService=n,this.actionProvider=i,r.isMacintosh?this.downKeyBindings["Meta-Backspace"]=this.onDelete.bind(this):(this.downKeyBindings.Delete=this.onDelete.bind(this),this.downKeyBindings["Shift-Delete"]=this.onDelete.bind(this))}return __extends(t,e),t.prototype.onContextMenu=function(e,t,n){var r=this;if(n.target&&n.target.tagName&&"input"===n.target.tagName.toLowerCase())return!1;if(n.preventDefault(),n.stopPropagation(),e.setFocus(t),this.actionProvider.hasSecondaryActions(e,t)){var i={x:n.posx+1,y:n.posy};return this.contextMenuService.showContextMenu({getAnchor:function(){return i},getActions:function(){return r.actionProvider.getSecondaryActions(e,t)},onHide:function(t){t&&e.DOMFocus()}}),!0}return!1},t.prototype.onDelete=function(){return!1},t}(h.DefaultController);t.BaseDebugController=S;var k=function(){function e(){}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){return t instanceof y.Model||t instanceof y.Thread},e.prototype.getChildren=function(e,t){if(t instanceof y.Thread)return n.Promise.as(t.callStack);var r=t.getThreads(),i=[];for(var o in r)r.hasOwnProperty(o)&&i.push(r[o]);return 1===i.length?n.Promise.as(i[0].callStack):n.Promise.as(i)},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.CallStackDataSource=k;var C=function(e){function t(t,n,r){e.call(this,t,n,r)}return __extends(t,e),t.prototype.renderContents=function(e,t,n){if(t instanceof y.Thread){var r=t,i=b(n,"div","thread");i.textContent=r.name}else{var o=b(n,"div","stack-frame"),s=b(o,"span","label"),c=b(o,"div","file"),l=b(c,"span","file-name"),p=b(c,"span","line-number"),d=t;c.title=d.source.uri.fsPath,s.textContent=d.name,l.textContent=d.source.inMemory?d.source.name:u.getPathLabel(a.basename(d.source.uri.fsPath),this.contextService),p.textContent=""+d.lineNumber}return null},t}(T);t.CallStackRenderer=C;var w=function(e){function t(t){e.call(this),this.instantiationService=t}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof y.WatchExpression&&t.name!==y.WatchExpression.UNNAMED},t.prototype.hasSecondaryActions=function(){return!0},t.prototype.getActions=function(e,t){return n.Promise.as([this.instantiationService.createInstance(_.RemoveWatchExpressionAction,_.RemoveWatchExpressionAction.ID,_.RemoveWatchExpressionAction.LABEL,t)])},t.prototype.getSecondaryActions=function(e,t){var r=[];return t instanceof y.Variable?(r.push(this.instantiationService.createInstance(_.AddToWatchExpressionsAction,_.AddToWatchExpressionsAction.ID,_.AddToWatchExpressionsAction.LABEL,t)),r.push(this.instantiationService.createInstance(_.CopyVariableValueAction,_.CopyVariableValueAction.ID,_.CopyVariableValueAction.LABEL,t))):(r.push(this.instantiationService.createInstance(_.AddWatchExpressionAction,_.AddWatchExpressionAction.ID,_.AddWatchExpressionAction.LABEL)),r.push(new d.Separator),r.push(this.instantiationService.createInstance(_.RemoveWatchExpressionAction,_.RemoveWatchExpressionAction.ID,_.RemoveWatchExpressionAction.LABEL,t)),r.push(this.instantiationService.createInstance(_.RemoveAllWatchExpressionsAction,_.RemoveAllWatchExpressionsAction.ID,_.RemoveAllWatchExpressionsAction.LABEL))),n.Promise.as(r)},t}(E);t.ExpressionsActionProvider=w;var x=function(){function e(e){this.debugService=e}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){if(t instanceof v.ViewModel||t instanceof y.Scope||t instanceof y.Model)return!0;var n=t;return 0!==n.reference&&!c.equalsIgnoreCase(n.value,"null")},e.prototype.getChildren=function(e,t){if(t instanceof v.ViewModel){var r=t.getFocusedStackFrame();return r?n.Promise.as(r.scopes):n.Promise.as([])}if(t instanceof y.Model)return n.Promise.as(t.getWatchExpressions());var i=t;return i.getChildren(this.debugService)},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.ExpressionsDataSource=x;var A=function(e){function t(t,n,r,i,o,a){e.call(this,r,i,o),this.debugService=t,this.contextViewService=n,this.selectableWatches=a}return __extends(t,e),t.prototype.renderContents=function(e,t,n){return t instanceof y.Scope?this.renderScope(t,n):this.renderExpression(e,t,n)},t.prototype.renderScope=function(e,t){var n=b(t,"div","scope");return n.textContent=e.name,null},t.prototype.renderExpression=function(e,n,r){var i=b(r,"div","expression");if(this.selectableWatches[n.getId()]||n.name===y.WatchExpression.UNNAMED){var o=n instanceof y.WatchExpression;return this.createExpressionInputBox(e,i,o,n)}var a=b(i,"span","name");if(a.textContent=n.name,n.value){var s=b(i,"span","value");null===n.name||n instanceof y.WatchExpression&&!n.available?(l.addClass(s,"unavailable"),this.debugService.getState()!==g.State.Inactive?l.addClass(s,"error"):l.removeClass(s,"error")):isNaN(+n.value)?t.BOOLEAN_REGEX.test(n.value)?l.addClass(s,"boolean"):t.STRING_REGEX.test(n.value)&&l.addClass(s,"string"):l.addClass(s,"number"),s.textContent=n.value,s.title=n.value}return null},t.prototype.createExpressionInputBox=function(e,t,n,r){var o=this,a=new m.InputBox(t,this.contextViewService,{validationOptions:{validation:null,showMessage:!1}});n||(a.inputElement.readOnly=!0),a.value=n?r.name:r.value,a.focus();var c=!1,u=[a],p=s.once(function(t){c||(c=!0,t&&a.value?o.debugService.renameWatchExpression(r.getId(),a.value):r.name===y.WatchExpression.UNNAMED&&o.debugService.clearWatchExpressions(r.getId()),e.clearHighlight(),e.DOMFocus(),i.disposeAll(u))});return u.push(l.addStandardDisposableListener(a.inputElement,"keydown",function(e){("Escape"===e.asString()||"Enter"===e.asString())&&p(n&&"Enter"===e.asString())})),u.push(l.addDisposableListener(a.inputElement,"blur",function(){p(n)})),p},t.BOOLEAN_REGEX=/^true|false$/i,t.STRING_REGEX=/^(['"]).*\1$/,t}(T);t.ExpressionsRenderer=A;var L=function(e){function t(t,n,i,o){e.call(this,t,n,i),this.selectableExpressions=o,r.isMacintosh?this.downKeyBindings.Enter=this.onRename.bind(this):this.downKeyBindings.F2=this.onRename.bind(this)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r){return(n instanceof y.WatchExpression||n instanceof y.Variable)&&2===r.detail?(this.triggerExpressionSelection(t,n),!0):e.prototype.onLeftClick.call(this,t,n,r)},t.prototype.triggerExpressionSelection=function(e,t){var n=this,r=t;0===r.reference&&(this.selectableExpressions[r.getId()]=!0,e.refresh(r,!1).then(function(){e.setHighlight(r);var t=e.addListener(p.EventType.HIGHLIGHT,function(i){i.highlight||(n.selectableExpressions[r.getId()]=!1,e.refresh(r).done(null,o.onUnexpectedError),t())})}).done(null,o.onUnexpectedError))},t.prototype.onRename=function(e){var t=e.getFocus();return t instanceof y.WatchExpression?(this.triggerExpressionSelection(e,t),!0):!1},t.prototype.onDelete=function(e){var t=e.getFocus();if(t instanceof y.WatchExpression){var n=t;return this.debugService.clearWatchExpressions(n.getId()),!0}return!1},t}(S);t.ExpressionsController=L;var N=function(e){function t(t){e.call(this),this.instantiationService=t}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof y.Breakpoint},t.prototype.hasSecondaryActions=function(e,t){return t instanceof y.Breakpoint||t instanceof y.ExceptionBreakpoint},t.prototype.getActions=function(e,t){return t instanceof y.Breakpoint?n.Promise.as([this.instantiationService.createInstance(_.RemoveBreakpointAction,_.RemoveBreakpointAction.ID,_.RemoveBreakpointAction.LABEL,t)]):n.Promise.as([])},t.prototype.getSecondaryActions=function(e,t){var r=[this.instantiationService.createInstance(_.ToggleEnablementAction,_.ToggleEnablementAction.ID,_.ToggleEnablementAction.LABEL,t)];return r.push(new d.Separator),r.push(this.instantiationService.createInstance(_.RemoveBreakpointAction,_.RemoveBreakpointAction.ID,_.RemoveBreakpointAction.LABEL,t)),r.push(this.instantiationService.createInstance(_.RemoveAllBreakpointsAction,_.RemoveAllBreakpointsAction.ID,_.RemoveAllBreakpointsAction.LABEL)),r.push(new d.Separator),r.push(this.instantiationService.createInstance(_.ToggleBreakpointsActivatedAction,_.ToggleBreakpointsActivatedAction.ID,_.ToggleBreakpointsActivatedAction.LABEL)),r.push(new d.Separator),r.push(this.instantiationService.createInstance(_.EnableAllBreakpointsAction,_.EnableAllBreakpointsAction.ID,_.EnableAllBreakpointsAction.LABEL)),r.push(this.instantiationService.createInstance(_.DisableAllBreakpointsAction,_.DisableAllBreakpointsAction.ID,_.DisableAllBreakpointsAction.LABEL)),r.push(new d.Separator),r.push(this.instantiationService.createInstance(_.ReapplyBreakpointsAction,_.ReapplyBreakpointsAction.ID,_.ReapplyBreakpointsAction.LABEL)),n.Promise.as(r)},t}(E);t.BreakpointsActionProvider=N;var P=function(){function e(){}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){return t instanceof y.Model},e.prototype.getChildren=function(e,t){var r=t,i=r.getExceptionBreakpoints();return n.Promise.as(i.concat(r.getBreakpoints()))},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.BreakpointsDataSource=P;var O=function(e){function t(t,n,r,i){e.call(this,n,r,i),this.debugService=t,this.toDispose=[]}return __extends(t,e),t.prototype.renderContents=function(e,t,n){var r=b(n,"div","breakpoint");r.appendChild(this.createCheckbox(t));var i=b(r,"span","name");if(t instanceof y.Breakpoint){this.debugService.getModel().areBreakpointsActivated()?e.removeTraits("disabled",[t]):e.addTraits("disabled",[t]);var o=t,s=b(r,"span","line-number"),l=b(r,"span","file-path");i.textContent=u.getPathLabel(a.basename(o.source.uri.fsPath),this.contextService),s.textContent=o.desiredLineNumber!==o.lineNumber?o.desiredLineNumber+" → "+o.lineNumber:""+o.lineNumber,l.textContent=u.getPathLabel(a.dirname(o.source.uri.fsPath),this.contextService)}else{var p=t,d=p.name.charAt(0).toUpperCase()+p.name.slice(1);i.textContent=c.format("{0} exceptions",d)}return null},t.prototype.createCheckbox=function(e){var t=this,n=document.createElement("input");return n.type="checkbox",n.className="checkbox",n.checked=e.enabled,this.toDispose.push(l.addStandardDisposableListener(n,"change",function(){t.debugService.toggleEnablement(e)})),n},t.prototype.dispose=function(){this.debugService=null,this.toDispose=i.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(T);t.BreakpointsRenderer=O;var I=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r,i){return void 0===i&&(i="mouse"),n instanceof y.ExceptionBreakpoint?!1:e.prototype.onLeftClick.call(this,t,n,r,i)},t.prototype.onUp=function(t,n){return this.doNotFocusExceptionBreakpoint(t,e.prototype.onUp.call(this,t,n))},t.prototype.onPageUp=function(t,n){return this.doNotFocusExceptionBreakpoint(t,e.prototype.onPageUp.call(this,t,n))},t.prototype.doNotFocusExceptionBreakpoint=function(e,t){if(t){var n=e.getFocus();n instanceof y.ExceptionBreakpoint&&e.focusNth(2)}return t},t.prototype.onDelete=function(e){var t=e.getFocus();if(t instanceof y.Breakpoint){var n=t;return this.debugService.toggleBreakpoint(n.source.uri,n.lineNumber),!0}return!1},t}(S);t.BreakpointsController=I});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/parts/debug/browser/debugActionItems",["require","exports","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/browser/ui/actionbar/actionbar","vs/workbench/parts/debug/common/debug","vs/platform/configuration/common/configuration"],function(e,t,n,r,i,o,a){var s=function(e){function t(t,n){e.call(this,t,n),this.debugService=t.debugService,this.select=document.createElement("select"),this.select.className="debug-select action-bar-select",this.toDispose=[],this.registerListeners(t)}return __extends(t,e),t.prototype.registerListeners=function(e){var t=this;this.toDispose.push(r.addStandardDisposableListener(this.select,"change",function(e){t.actionRunner.run(t._action,e.target.value).done()})),this.toDispose.push(this.debugService.addListener2(o.ServiceEvents.STATE_CHANGED,function(){t.select.disabled=t.debugService.getState()!==o.State.Inactive})),this.toDispose.push(e.configurationService.addListener2(a.ConfigurationServiceEventTypes.UPDATED,function(){t.setOptions().done()}))},t.prototype.render=function(e){r.addClass(e,"select-container"),e.appendChild(this.select),this.setOptions().done()},t.prototype.setOptions=function(){var e=this,t=this.select.selectedIndex;return this.select.options.length=0,this.debugService.loadLaunchConfig().then(function(n){if(!n||!n.configurations)return e.select.options.add(e.createOption("<none>")),e.select.disabled=!0,void 0;var r=n.configurations;e.select.disabled=r.length<1;for(var i=!1,o=0;o<r.length;o++)e.select.options.add(e.createOption(r[o].name)),r[o].name===e.debugService.selectedConfigName&&(e.select.selectedIndex=o,i=!0);return!i&&r.length>0?((!t||0>t||t>=r.length)&&(t=0),e.select.selectedIndex=t,e.actionRunner.run(e._action,r[t].name)):void 0})},t.prototype.createOption=function(e){var t=document.createElement("option");return t.value=e,t.text=e,t},t.prototype.dispose=function(){this.debugService=null,this.toDispose=n.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(i.BaseActionItem);t.SelectConfigActionItem=s}),define("vs/css!vs/workbench/parts/debug/browser/media/debugViewlet",["vs/css!vs/workbench/parts/debug/browser/debugViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/debug/browser/debugViewlet",["require","exports","vs/nls!vs/workbench/parts/debug/browser/debugViewlet","vs/base/browser/dom","vs/base/browser/builder","vs/base/common/winjs.base","vs/base/common/lifecycle","vs/workbench/browser/ui/actionBarRegistry","vs/base/parts/tree/browser/treeImpl","vs/base/browser/ui/splitview/splitview","vs/workbench/browser/ui/viewlet","vs/workbench/parts/debug/common/debug","vs/workbench/parts/debug/common/debugModel","vs/workbench/parts/debug/browser/debugViewer","vs/workbench/parts/debug/browser/debugActions","vs/workbench/parts/debug/browser/debugActionItems","vs/platform/contextview/browser/contextView","vs/platform/instantiation/common/instantiation","vs/platform/progress/common/progress","vs/platform/workspace/common/workspace","vs/platform/telemetry/common/telemetry","vs/platform/message/browser/message","vs/css!./media/debugViewlet"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f,g,y,v,_,b,T){function E(e){var t=document.createElement("div");return r.addClass(t,"debug-view-content"),e.appendChild(t),t}var S=p.IDebugService,k={indentPixels:8,twistiePixels:20},C=i.$,w=function(e){function t(t,n,r,i,o,a,s){e.call(this,t,"variablesView",n,r),this.debugService=i,this.contextService=o,this.contextViewService=a,this.instantiationService=s,this.actionProvider=new m.ExpressionsActionProvider(this.instantiationService)}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=C("div.title").appendTo(t);C("span").text(n.localize("vs_workbench_parts_debug_browser_debugViewlet",0)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=E(e),r.addClass(this.treeContainer,"debug-variables");var n={};this.tree=new c.Tree(this.treeContainer,{dataSource:new m.ExpressionsDataSource(this.debugService),renderer:new m.ExpressionsRenderer(this.debugService,this.contextViewService,this.contextService,this.actionProvider,this.actionRunner,n),controller:new m.ExpressionsController(this.debugService,this.contextMenuService,this.actionProvider,n)},k);var i=this.debugService.getViewModel();this.tree.setInput(i);var o=this.instantiationService.createInstance(u.CollapseAction,this.tree,!1,"explorer-action collapse-explorer");this.toolBar.setActions(s.prepareActions([o]))(),this.toDispose.push(i.addListener2(p.ViewModelEvents.FOCUSED_STACK_FRAME_UPDATED,function(){return t.onFocusedStackFrameUpdated()})),this.toDispose.push(this.debugService.addListener2(p.ServiceEvents.STATE_CHANGED,function(){o.enabled=t.debugService.getState()===p.State.Running||t.debugService.getState()===p.State.Stopped}))},t.prototype.onFocusedStackFrameUpdated=function(){var e=this;this.tree.refresh().done(function(){var t=e.debugService.getViewModel().getFocusedStackFrame();return t&&t.scopes.length>0?e.tree.expand(t.scopes[0]):void 0})},t=__decorate([__param(1,T.IMessageService),__param(2,g.IContextMenuService),__param(3,S),__param(4,_.IWorkspaceContextService),__param(5,g.IContextViewService),__param(6,y.IInstantiationService)],t)}(u.CollapsibleViewletView),x=function(e){function t(t,n,r,i,o,a,s){e.call(this,t,"expressionsView",n,r),this.debugService=i,this.instantiationService=s,this.contextService=o,this.contextViewService=a,this.actionProvider=new m.ExpressionsActionProvider(this.instantiationService)}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=C("div.title").appendTo(t);C("span").text(n.localize("vs_workbench_parts_debug_browser_debugViewlet",1)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=E(e),r.addClass(this.treeContainer,"debug-watch");var n={};this.tree=new c.Tree(this.treeContainer,{dataSource:new m.ExpressionsDataSource(this.debugService),renderer:new m.ExpressionsRenderer(this.debugService,this.contextViewService,this.contextService,this.actionProvider,this.actionRunner,n),controller:new m.ExpressionsController(this.debugService,this.contextMenuService,this.actionProvider,n)},k);var i=this.debugService.getModel();this.tree.setInput(i);var o=this.instantiationService.createInstance(h.AddWatchExpressionAction,h.AddWatchExpressionAction.ID,h.AddWatchExpressionAction.LABEL),a=this.instantiationService.createInstance(u.CollapseAction,this.tree,!1,"explorer-action collapse-explorer"),l=this.instantiationService.createInstance(h.RemoveAllWatchExpressionsAction,h.RemoveAllWatchExpressionsAction.ID,h.RemoveAllWatchExpressionsAction.LABEL);this.toolBar.setActions(s.prepareActions([o,a,l]))(),this.toDispose.push(this.debugService.getModel().addListener2(p.ModelEvents.WATCH_EXPRESSIONS_UPDATED,function(){return t.onWatchExpressionsUpdated()})),this.toDispose.push(this.debugService.addListener2(p.ServiceEvents.STATE_CHANGED,function(){a.enabled=t.debugService.getState()===p.State.Running||t.debugService.getState()===p.State.Stopped,t.debugService.getState()===p.State.Inactive&&t.onWatchExpressionsUpdated()}))},t.prototype.onWatchExpressionsUpdated=function(){this.tree.refresh().done()},t=__decorate([__param(1,T.IMessageService),__param(2,g.IContextMenuService),__param(3,S),__param(4,_.IWorkspaceContextService),__param(5,g.IContextViewService),__param(6,y.IInstantiationService)],t)}(u.CollapsibleViewletView),A=function(e){function t(t,n,r,i,o){e.call(this,t,"callStackView",n,r),this.debugService=i,this.contextService=o}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=C("div.title").appendTo(t);C("span").text(n.localize("vs_workbench_parts_debug_browser_debugViewlet",2)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.renderMessageBox(e),this.treeContainer=E(e),r.addClass(this.treeContainer,"debug-call-stack"),this.tree=new c.Tree(this.treeContainer,{dataSource:new m.CallStackDataSource,renderer:new m.CallStackRenderer(this.contextService,new m.SimpleActionProvider,this.actionRunner)},k);var i=this.debugService.getModel();this.tree.setInput(i),this.toDispose.push(this.tree.addListener2("selection",function(e){if(e.selection.length){var n=e.selection[0];if(n instanceof d.StackFrame){var r=n;t.debugService.setFocusedStackFrameAndEvaluate(r);var i="mouse"===e.payload.origin,o=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);t.debugService.openOrRevealEditor(r.source,r.lineNumber,i,o)}}})),this.toDispose.push(i.addListener2(p.ModelEvents.THREADS_UPDATED,function(){t.tree.refresh()})),this.toDispose.push(this.debugService.addListener2(p.ServiceEvents.STATE_CHANGED,function(e){return t.debugService.getState()===p.State.Stopped&&"step"!==e?(t.messageBox.textContent=n.localize("vs_workbench_parts_debug_browser_debugViewlet",3,e),"exception"===e?t.messageBox.classList.add("exception"):t.messageBox.classList.remove("exception"),t.messageBox.hidden=!1,void 0):(t.messageBox.hidden=!0,void 0)})),this.toDispose.push(this.debugService.getViewModel().addListener2(p.ViewModelEvents.FOCUSED_STACK_FRAME_UPDATED,function(){var e=t.debugService.getViewModel().getFocusedStackFrame();if(e){var n=t.debugService.getModel().getThreads();for(var r in n)n[r].callStack.some(function(t){return t===e})&&t.tree.expand(n[r]);t.tree.setFocus(e)}}))},t.prototype.renderMessageBox=function(e){this.messageBox=document.createElement("div"),r.addClass(this.messageBox,"debug-message-box"),this.messageBox.hidden=!0,e.appendChild(this.messageBox)},t=__decorate([__param(1,T.IMessageService),__param(2,g.IContextMenuService),__param(3,S),__param(4,_.IWorkspaceContextService)],t)}(u.CollapsibleViewletView),L=function(e){function t(n,r,i,o,a,s){var c=this,l=o.getModel().getBreakpoints().length+o.getModel().getExceptionBreakpoints().length;e.call(this,n,t.getExpandedBodySize(l),!1,"breakpointsView",r,i),this.debugService=o,this.contextService=a,this.instantiationService=s,this.actionProvider=new m.BreakpointsActionProvider(this.instantiationService),this.toDispose.push(this.debugService.getModel().addListener2(p.ModelEvents.BREAKPOINTS_UPDATED,function(){return c.onBreakpointsChange()}))}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=C("div.title").appendTo(t);C("span").text(n.localize("vs_workbench_parts_debug_browser_debugViewlet",4)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=E(e),r.addClass(this.treeContainer,"debug-breakpoints"),this.tree=new c.Tree(this.treeContainer,{dataSource:new m.BreakpointsDataSource,renderer:new m.BreakpointsRenderer(this.debugService,this.contextService,this.actionProvider,this.actionRunner),controller:new m.BreakpointsController(this.debugService,this.contextMenuService,this.actionProvider),sorter:{compare:function(e,t,n){var r=t,i=n;return r instanceof d.ExceptionBreakpoint?-1:i instanceof d.ExceptionBreakpoint?1:r.source.uri.toString()!==i.source.uri.toString()?r.source.uri.toString().localeCompare(i.source.uri.toString()):r.desiredLineNumber-i.desiredLineNumber}}},k);var n=this.debugService.getModel();this.tree.setInput(n),this.toDispose.push(this.tree.addListener2("selection",function(e){if(e.selection.length){var n=e.selection[0];if(n instanceof d.Breakpoint){var r=n;if(!r.source.inMemory){var i="mouse"===e.payload.origin,o=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);t.debugService.openOrRevealEditor(r.source,r.lineNumber,i,o)}}}})),this.tree.refresh()},t.prototype.getActions=function(){return[this.instantiationService.createInstance(h.ReapplyBreakpointsAction,h.ReapplyBreakpointsAction.ID,h.ReapplyBreakpointsAction.LABEL),this.instantiationService.createInstance(h.ToggleBreakpointsActivatedAction,h.ToggleBreakpointsActivatedAction.ID,h.ToggleBreakpointsActivatedAction.LABEL),this.instantiationService.createInstance(h.RemoveAllBreakpointsAction,h.RemoveAllBreakpointsAction.ID,h.RemoveAllBreakpointsAction.LABEL)]},t.prototype.onBreakpointsChange=function(){this.expandedBodySize=t.getExpandedBodySize(this.debugService.getModel().getBreakpoints().length+this.debugService.getModel().getExceptionBreakpoints().length),this.tree&&this.tree.refresh()},t.getExpandedBodySize=function(e){return Math.min(t.MAX_VISIBLE_FILES,e)*m.AbstractRenderer.ELEMENT_HEIGHT},t.MAX_VISIBLE_FILES=9,t=__decorate([__param(1,T.IMessageService),__param(2,g.IContextMenuService),__param(3,S),__param(4,_.IWorkspaceContextService),__param(5,y.IInstantiationService)],t)}(u.AdaptiveCollapsibleViewletView),N=function(e){function t(t,n,r,i,o){var a=this;e.call(this,p.VIEWLET_ID,t),this.progressService=n,this.debugService=r,this.instantiationService=i,this.contextService=o,this.progressRunner=null,this.toDispose=[],this.toDispose.push(this.debugService.addListener2(p.ServiceEvents.STATE_CHANGED,function(){a.onDebugServiceStateChange()}))}return __extends(t,e),t.prototype.create=function(t){e.prototype.create.call(this,t),this.$el=t.div().addClass("debug-viewlet"),this.splitView=new l.SplitView(this.$el.getHTMLElement());var n=this.getActionRunner();return this.splitView.addView(this.instantiationService.createInstance(w,n)),this.splitView.addView(this.instantiationService.createInstance(x,n)),this.splitView.addView(this.instantiationService.createInstance(A,n)),this.splitView.addView(this.instantiationService.createInstance(L,n)),o.Promise.as(null)},t.prototype.layout=function(t){e.prototype.layout.call(this,t),this.splitView&&this.splitView.layout(t.height)},t.prototype.getActions=function(){var e=this;return this.actions||(this.actions=[this.instantiationService.createInstance(h.StartDebugAction,h.StartDebugAction.ID,h.StartDebugAction.LABEL),this.instantiationService.createInstance(h.SelectConfigAction,h.SelectConfigAction.ID,h.SelectConfigAction.LABEL),this.instantiationService.createInstance(h.ConfigureAction,h.ConfigureAction.ID,h.ConfigureAction.LABEL)],this.actions.forEach(function(t){e.toDispose.push(t)})),this.actions},t.prototype.getActionItem=function(e){return e.id===h.SelectConfigAction.ID?this.instantiationService.createInstance(f.SelectConfigActionItem,e):null},t.prototype.getSecondaryActions=function(){return[]},t.prototype.onDebugServiceStateChange=function(){this.progressRunner&&this.progressRunner.done(),this.progressRunner=this.debugService.getState()===p.State.Initializing?this.progressService.show(!0):null},t.prototype.dispose=function(){this.toDispose=a.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t=__decorate([__param(0,b.ITelemetryService),__param(1,v.IProgressService),__param(2,S),__param(3,y.IInstantiationService),__param(4,_.IWorkspaceContextService)],t)}(u.Viewlet);t.DebugViewlet=N});