/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/common/searchModel",["require","exports","vs/base/common/async","vs/base/common/strings","vs/base/common/paths","vs/base/common/lifecycle","vs/base/common/collections","vs/base/common/eventEmitter","vs/editor/common/common","vs/editor/common/core/range","vs/editor/common/services/modelService"],function(e,t,n,r,i,o,a,s,c,u,l){var p=function(){function e(e,t,n,r,i){this._parent=e,this._lineText=t,this._id=e.id()+">"+n+">"+r,this._range=u.Range.create(1+n,1+r,1+n,1+r+i)}return e.prototype.id=function(){return this._id},e.prototype.parent=function(){return this._parent},e.prototype.text=function(){return this._lineText},e.prototype.range=function(){return this._range},e.prototype.preview=function(){var e=this._lineText.substring(0,this._range.startColumn-1),t=this._lineText.substring(this._range.startColumn-1,this._range.endColumn-1),n=this._lineText.substring(this._range.endColumn-1,Math.min(this._range.endColumn+150,this._lineText.length));return e=r.lcut(e,26),{before:e,inside:t,after:n}},e}();t.Match=p;var d=function(e){function t(t){e.call(this,t,null,Date.now(),Date.now(),Date.now())}return __extends(t,e),t}(p);t.EmptyMatch=d;var m=function(){function e(e,t){this._resource=t,this._parent=e,this._matches=Object.create(null)}return e.prototype.dispose=function(){},e.prototype.id=function(){return this.resource().toString()},e.prototype.parent=function(){return this._parent},e.prototype.add=function(e){this._matches[e.id()]=e},e.prototype.remove=function(e){delete this._matches[e.id()]},e.prototype.matches=function(){return a.values(this._matches)},e.prototype.count=function(){var e=0;for(var t in this._matches)this._matches[t]instanceof d||(e+=1);return e},e.prototype.resource=function(){return this._resource},e.prototype.name=function(){return i.basename(this.resource().fsPath)},e}();t.FileMatch=m;var h=function(e){function t(t,r,i,o,a){var s=this;e.call(this,t,r),this._modelDecorations=[],this._unbind=[],this._query=i,this._model=o,this._diskFileMatch=a,this._updateScheduler=new n.RunOnceScheduler(this._updateMatches.bind(this),250),this._unbind.push(this._model.addListener(c.EventType.ModelContentChanged,function(){return s._updateScheduler.schedule()})),this._updateMatches()}return __extends(t,e),t.prototype.dispose=function(){this._unbind=o.cAll(this._unbind),this._isTextModelDisposed()||this._model.deltaDecorations(this._modelDecorations,[])},t.prototype._updateMatches=function(){var e=this;if(!this._isTextModelDisposed()){this._matches=Object.create(null);var t=this._model.findMatches(this._query.pattern,this._model.getFullModelRange(),this._query.isRegExp,this._query.isCaseSensitive,this._query.isWordMatch);0===t.length?this.add(new d(this)):t.forEach(function(t){return e.add(new p(e,e._model.getLineContent(t.startLineNumber),t.startLineNumber-1,t.startColumn-1,t.endColumn-t.startColumn))}),this.parent().emit("changed",this),this.updateHighlights()}},t.prototype.updateHighlights=function(){this._model.isDisposed()||(this._modelDecorations=this.parent()._showHighlights?this._model.deltaDecorations(this._modelDecorations,this.matches().filter(function(e){return!(e instanceof d)}).map(function(e){return{range:e.range(),options:t.DecorationOption}})):this._model.deltaDecorations(this._modelDecorations,[]))},t.prototype._isTextModelDisposed=function(){return!this._model||this._model.isDisposed()},t.DecorationOption={stickiness:c.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,isOverlay:!1,className:"findMatch",overviewRuler:{color:"rgba(246, 185, 77, 0.7)",position:c.OverviewRulerLane.Center}},t}(m);t.LiveFileMatch=h;var f=function(e){function t(t,n){e.call(this),this._disposables=[],this._matches=Object.create(null),this._modelService=n,this._query=t,this._query&&(this._modelService.onModelAdded.add(this._onModelAdded,this,this._disposables),this._modelService.onModelRemoved.add(this._onModelRemoved,this,this._disposables))}return __extends(t,e),t.prototype._onModelAdded=function(e){var t=e.getAssociatedResource(),n=this._matches[t.toString()];if(n){var r=new h(this,t,this._query,e,n);r.updateHighlights(),this._matches[t.toString()]=r,this.emit("changed",this)}},t.prototype._onModelRemoved=function(e){var t=this,n=e.getAssociatedResource(),r=this._matches[n.toString()];r instanceof h&&this.deferredEmit(function(){t.remove(r),t._matches[n.toString()]=r._diskFileMatch})},t.prototype.append=function(e){var t=this;e.forEach(function(e){var n=t._getOrAdd(e);n instanceof h&&(n=n._diskFileMatch),e.lineMatches.forEach(function(e){e.offsetAndLengths.forEach(function(t){var r=new p(n,e.preview,e.lineNumber,t[0],t[1]);n.add(r)})})})},t.prototype._getOrAdd=function(e){var t=this;return a.lookupOrInsert(this._matches,e.resource.toString(),function(){var n=t._modelService.getModel(e.resource),r=new m(t,e.resource);return n&&t._query&&(r=new h(t,e.resource,t._query,n,r)),r})},t.prototype.remove=function(e){delete this._matches[e.resource().toString()],e.dispose(),this.emit("changed",this)},t.prototype.matches=function(){return a.values(this._matches)},t.prototype.isEmpty=function(){return 0===this.fileCount()},t.prototype.fileCount=function(){return Object.keys(this._matches).length},t.prototype.count=function(){return this.matches().reduce(function(e,t){return e+t.count()},0)},t.prototype.toggleHighlights=function(e){if(this._showHighlights!==e){this._showHighlights=e;for(var t in this._matches){var n=this._matches[t];n instanceof h&&n.updateHighlights()}}},t.prototype.dispose=function(){this._disposables=o.disposeAll(this._disposables),o.disposeAll(this.matches()),e.prototype.dispose.call(this)},t=__decorate([__param(1,l.IModelService)],t)}(s.EventEmitter);t.SearchResult=f}),define("vs/workbench/parts/search/common/searchQuery",["require","exports","vs/base/common/assert","vs/base/common/types","vs/base/common/objects","vs/base/common/winjs.base","vs/base/common/lifecycle","vs/platform/search/common/search","vs/platform/configuration/common/configuration"],function(e,t,n,r,i,o,a,s,c){function u(e){var t=e&&e.files&&e.files.exclude,n=e&&e.search&&e.search.exclude;if(!t&&!n)return null;if(!t||!n)return t||n;var r=Object.create(null);return r=i.mixin(r,t),r=i.mixin(r,n,!0)}t.getExcludes=u;var l=function(){function e(e){var t=this;this.configurationService=e.configurationService,this.callOnDispose=[],this.callOnDispose.push(this.configurationService.addListener(c.ConfigurationServiceEventTypes.UPDATED,function(e){t.configurationPromise=o.Promise.as(e.config)}))}return e.prototype.dispose=function(){a.cAll(this.callOnDispose)},e.prototype.text=function(e,t){return this._query(s.QueryType.Text,e,t)},e.prototype.file=function(e){return this._query(s.QueryType.File,null,e)},e.prototype._query=function(e,t,n){return void 0===n&&(n={}),this.loadConfiguration().then(function(r){var o=r&&r.files&&r.files.encoding;n.fileEncoding=o;var a=u(r);return n.excludePattern?i.mixin(n.excludePattern,a,!1):n.excludePattern=a,new p(e,t,n)})},e.prototype.loadConfiguration=function(){return this.configurationPromise?this.configurationPromise:(this.configurationPromise=this.configurationService.loadConfiguration(),this.configurationPromise)},e}();t.QueryBuilder=l;var p=function(){function e(e,t,i){void 0===i&&(i={}),n.ok(!r.isUndefinedOrNull(e)),n.ok(e!==s.QueryType.Text||t&&t.pattern&&0!==t.pattern.length),this._type=e,this._contentPattern=t,this._filePatterns=i.filePatterns||[],this._excludePattern=i.excludePattern,this._includePattern=i.includePattern,this._maxResults=i.maxResults,this._rootResources=i.rootResources,this._fileEncoding=i.fileEncoding}return Object.defineProperty(e.prototype,"type",{get:function(){return this._type},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentPattern",{get:function(){return this._contentPattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filePatterns",{get:function(){return this._filePatterns},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"excludePattern",{get:function(){return this._excludePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"includePattern",{get:function(){return this._includePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"maxResults",{get:function(){return this._maxResults},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"rootResources",{get:function(){return this._rootResources},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fileEncoding",{get:function(){return this._fileEncoding},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){return{type:this.type,contentPattern:this.contentPattern,filePatterns:this.filePatterns,excludePattern:this._excludePattern,includePattern:this._includePattern,maxResults:this._maxResults,rootResources:this._rootResources,fileEncoding:this._fileEncoding}},e}()});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/browser/openFileHandler",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/search/browser/openAnythingHandler","vs/base/common/async","vs/base/common/paths","vs/base/common/labels","vs/base/common/strings","vs/base/common/filters","vs/base/common/comparers","vs/workbench/common/quickopen","vs/workbench/parts/search/common/searchModel","vs/workbench/parts/search/common/searchQuery","vs/workbench/parts/files/common/files","vs/workbench/services/editor/common/editorService","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/instantiation","vs/platform/message/browser/message","vs/platform/search/common/search","vs/platform/workspace/common/workspace"],function(e,t,n,r,i,o,a,s,c,u,l,p,d,m,h,f,g,v,y,_){var b=function(e){function t(t,n,r,i,s,c){e.call(this,i),this.instantiationService=s,this.resource=n,this.name=t,this.description=a.getPathLabel(o.dirname(this.resource.fsPath),c),this.setHighlights(r)}return __extends(t,e),t.prototype.getLabel=function(){return this.name},t.prototype.getDescription=function(){return this.description},t.prototype.getIcon=function(){return"file"},t.prototype.getResource=function(){return this.resource},t.prototype.setRange=function(e){this.range=e},t.prototype.getInput=function(){var e={resource:this.resource};return this.range&&(e.options={selection:this.range}),e},t=__decorate([__param(3,h.IWorkbenchEditorService),__param(4,g.IInstantiationService),__param(5,_.IWorkspaceContextService)],t)}(l.EditorQuickOpenEntry);t.FileEntry=b;var E=function(e){function t(n,r,o,a,s,c,u,l){e.call(this),this.editorService=r,this.messageService=o,this.configurationService=s,this.searchService=l,this.contextService=c,this.textFileService=u,this.instantiationService=a,this.queryBuilder=this.instantiationService.createInstance(d.QueryBuilder),this.delayer=n?new i.ThrottledDelayer(t.SEARCH_DELAY):null,this.isStandalone=n}return __extends(t,e),t.prototype.dispose=function(){this.queryBuilder.dispose()},t.prototype.getResults=function(e){var t=this;return e=e.trim(),e?this.delayer?this.delayer.trigger(function(){return t.doFindResults(e)}):this.doFindResults(e):n.Promise.as([])},t.prototype.doFindResults=function(e){var t=this;this.cancelPendingSearch();var n=this.textFileService.getWorkingFilesModel().getOutOfWorkspaceContextEntries().map(function(e){return e.resource});this.contextService.getWorkspace()&&n.push(this.contextService.getWorkspace().resource);var r={filePatterns:[{pattern:e}],rootResources:n};return this.queryBuilder.file(r).then(function(e){return t.pendingSearch=t.searchService.search(e),t.pendingSearch}).then(function(n){t.pendingSearch=null;var r=t.instantiationService.createInstance(p.SearchResult,null);r.append(n.results);var i=[],o=r.matches();t.isStandalone&&(o=o.sort(function(n,r){return t.sort(n,r,e.toLowerCase())}));for(var a=0;a<o.length;a++){var s=o[a],u=c.matchesFuzzy(e,s.name());i.push(t.instantiationService.createInstance(b,s.name(),s.resource(),u))}return i})},t.prototype.sort=function(e,t,n){var r=e.name().toLowerCase(),i=t.name().toLowerCase(),o=0===r.indexOf(n),a=0===i.indexOf(n);if(o!==a)return o?-1:1;var c=u.compareFileNames(r,i);return 0!==c?c:s.localeCompare(e.resource().fsPath,t.resource().fsPath)},t.prototype.getGroupLabel=function(){return r.localize("vs_workbench_parts_search_browser_openFileHandler",0)},t.prototype.getAutoFocus=function(){return{autoFocusFirstEntry:!0}},t.prototype.cancelPendingSearch=function(){this.pendingSearch&&(this.pendingSearch.cancel(),this.pendingSearch=null)},t.prototype.onClose=function(){this.cancelPendingSearch()},t.SEARCH_DELAY=500,t=__decorate([__param(1,h.IWorkbenchEditorService),__param(2,v.IMessageService),__param(3,g.IInstantiationService),__param(4,f.IConfigurationService),__param(5,_.IWorkspaceContextService),__param(6,m.ITextFileService),__param(7,y.ISearchService)],t)}(l.QuickOpenHandler);t.OpenFileHandler=E});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/browser/openSymbolHandler",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/search/browser/openAnythingHandler","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/platform","vs/workbench/common/quickopen","vs/editor/common/modes/modesRegistry","vs/base/common/filters","vs/workbench/common/editor","vs/base/common/labels","vs/workbench/services/editor/common/editorService","vs/platform/instantiation/common/instantiation","vs/platform/workspace/common/workspace","vs/editor/common/services/modeService"],function(e,t,n,r,i,o,a,s,c,u,l,p,d,m,h,f,g,v){var y=function(e){function t(t,n,r,i,o,a,s,c){e.call(this,c),this.name=t,this.parameters=n,this.description=r,this.resource=i,this.type=o,this.range=a,this.setHighlights(s)}return __extends(t,e),t.prototype.getLabel=function(){return this.name+this.parameters},t.prototype.getName=function(){return this.name},t.prototype.getParameters=function(){return this.parameters},t.prototype.getDescription=function(){return this.description},t.prototype.getType=function(){return this.type},t.prototype.getIcon=function(){return this.type},t.prototype.getInput=function(){var e={resource:this.resource};return this.range&&(e.options={selection:this.range}),e},t}(u.EditorQuickOpenEntry),_=function(e){function t(n,r,i,a,s){e.call(this),this.editorService=r,this.instantiationService=a,this.contextService=s,this.modeService=i,this.delayer=n?new o.ThrottledDelayer(t.SEARCH_DELAY):null,this.isStandalone=n}return __extends(t,e),t.prototype.canRun=function(){var e=c.Registry.as(l.Extensions.EditorModes),n=t.MIMES.some(function(t){return e.isRegisteredMode(t)});return n?!0:r.localize("vs_workbench_parts_search_browser_openSymbolHandler",0)},t.prototype.getResults=function(e){var t=this;return e=e.trim(),e?this.delayer?this.delayer.trigger(function(){return t.doGetResults(e)}):this.doGetResults(e):n.Promise.as([])},t.prototype.doGetResults=function(e){var r=this,o=null,a=this.editorService.getActiveEditorInput();if(a){var u=d.asFileEditorInput(a);u&&u.getResource()&&(o=new s.URL(u.getResource()))}var p=(c.Registry.as(l.Extensions.EditorModes),n.Promise.join(t.MIMES.map(function(e){return r.modeService.getOrCreateMode(e)})));return p.then(function(){var a=[];return n.Promise.join(t.MIMES.map(function(t){var s=r.modeService.getMode(t);return s&&s.navigateTypesSupport?new n.Promise(function(t){s.navigateTypesSupport.getNavigateToItems(e,o).done(function(n){a.push.apply(a,r.toQuickOpenEntries(n,e)),t(a)},function(e){i.onUnexpectedError(e),t(a)})}):n.Promise.as(a)})).then(function(){return a})})},t.prototype.toQuickOpenEntries=function(e,n){for(var r=[],i=0;i<e.length;i++){var o=e[i];if(t.SUPPORTED_OPEN_TYPES.some(function(e){return o.type===e})){var a=p.matchesFuzzy(n,o.name);if(a){var s=o.resourceUri;if("file"===s.scheme){var c=m.getPathLabel(s,this.contextService),u=void 0;u=o.containerName===c?c:o.containerName===s.toString()&&o.containerName.indexOf("/")>=0?o.containerName.substr(o.containerName.lastIndexOf("/")+1):o.containerName&&o.containerName.indexOf(".")>=0?o.containerName.substr(o.containerName.lastIndexOf(".")+1):o.containerName||c,r.push(new y(o.name,o.parameters,u,s,o.type,o.range,a,this.editorService))}}}}return this.isStandalone?r.sort(this.sort.bind(this,n.toLowerCase())):r},t.prototype.sort=function(e,n,r){var i=n.getName().toLowerCase(),o=r.getName().toLowerCase(),s=a.localeCompare(i,o);if(0!==s)return s;var c=n.getType(),u=r.getType();return c!==u?t.SUPPORTED_OPEN_TYPES.indexOf(c)<t.SUPPORTED_OPEN_TYPES.indexOf(u)?-1:1:0},t.prototype.getGroupLabel=function(){return r.localize("vs_workbench_parts_search_browser_openSymbolHandler",1)},t.prototype.getEmptyLabel=function(e){return e.length>0?r.localize("vs_workbench_parts_search_browser_openSymbolHandler",2):r.localize("vs_workbench_parts_search_browser_openSymbolHandler",3)},t.prototype.getAutoFocus=function(e){return{autoFocusFirstEntry:!0,autoFocusPrefixMatch:e.trim()}},t.MIMES=["text/typescript","csharp"],t.SUPPORTED_OPEN_TYPES=["class","interface","enum","function","method"],t.SEARCH_DELAY=500,t=__decorate([__param(1,h.IWorkbenchEditorService),__param(2,v.IModeService),__param(3,f.IInstantiationService),__param(4,g.IWorkspaceContextService)],t)}(u.QuickOpenHandler);t.OpenSymbolHandler=_});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/browser/openAnythingHandler",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/search/browser/openAnythingHandler","vs/base/common/async","vs/base/common/types","vs/base/common/strings","vs/base/common/filters","vs/base/common/comparers","vs/workbench/common/quickopen","vs/workbench/parts/search/browser/openFileHandler","vs/workbench/parts/search/browser/openSymbolHandler","vs/base/common/severity","vs/platform/message/browser/message","vs/platform/instantiation/common/instantiation"],function(e,t,n,r,i,o,a,s,c,u,l,p,d,m,h){t.OpenSymbolHandler=p.OpenSymbolHandler;var f=function(e){function t(n,r){e.call(this),this.messageService=n,this.openSymbolHandler=r.createInstance(p.OpenSymbolHandler,!1),this.openFileHandler=r.createInstance(l.OpenFileHandler,!1),this.resultsToSearchCache={},this.delayer=new i.ThrottledDelayer(t.SEARCH_DELAY)}return __extends(t,e),t.prototype.getResults=function(e){var r=this;if(e=e.trim(),this.isClosed=!1,!e)return n.Promise.as([]);var i=this.findRange(e);if(i){var o=e.indexOf("#")>=0?e.indexOf("#"):e.indexOf(":");o>=0&&(e=e.substring(0,o))}var s=this.getResultsFromCache(e,i);if(s)return n.Promise.as(s);var u=function(){var o=!1,s=[];if(i)s.push(n.Promise.as([]));else{var u=function(e){return n.Promise.timeout(e).then(function(){return o?n.Promise.as([]):u(t.SYMBOL_SEARCH_SUBSEQUENT_TIMEOUT)})},p=r.openSymbolHandler.getResults(e),m=u(t.SYMBOL_SEARCH_INITIAL_TIMEOUT);s.push(n.Promise.any([p,m]).then(function(e){return e.value}))}return s.push(r.openFileHandler.getResults(e).then(function(e){return o=!0,e})),n.Promise.join(s).then(function(t){if(r.isClosed)return[];var n=t[0].concat(t[1]),o=a.stripWildcards(e.toLowerCase());return n.sort(function(e,t){return c.compareAnything(e.getLabel(),t.getLabel(),o)}),n.forEach(function(e){e instanceof l.FileEntry&&e.setRange(i)}),r.resultsToSearchCache[e]=n,n},function(e){r.messageService.show(d.Error,e)})};return this.delayer.trigger(u)},t.prototype.findRange=function(e){var n=null,r=t.HASH_LINE_PATTERN.exec(e)||t.COLON_LINE_PATTERN.exec(e);if(r&&r.length>1){var i=parseInt(r[1],10);if(o.isNumber(i)){if(n={startLineNumber:i,startColumn:1,endLineNumber:i,endColumn:1},r.length>3){var a=parseInt(r[3],10);o.isNumber(a)&&(n.startColumn=a,n.endColumn=a)}}else""===r[1]&&(n={startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1})}return n},t.prototype.getResultsFromCache=function(e,t){void 0===t&&(t=null);var n;for(var r in this.resultsToSearchCache)if(this.resultsToSearchCache.hasOwnProperty(r)&&0===e.indexOf(r)){n=this.resultsToSearchCache[r];break}if(!n)return null;for(var i=[],o=0;o<n.length;o++){var u=n[o];if(!t||u instanceof l.FileEntry){var p=s.matchesFuzzy(e,u.getLabel());p&&(u.setHighlights(p),i.push(u))}}var d=a.stripWildcards(e.toLowerCase());return i.sort(function(e,t){return c.compareAnything(e.getLabel(),t.getLabel(),d)}),i.forEach(function(e){e instanceof l.FileEntry&&e.setRange(t)}),i},t.prototype.getGroupLabel=function(){return r.localize("vs_workbench_parts_search_browser_openAnythingHandler",0)},t.prototype.getAutoFocus=function(){return{autoFocusFirstEntry:!0}},t.prototype.onClose=function(e){this.isClosed=!0,this.resultsToSearchCache={},this.openSymbolHandler.onClose(e),this.openFileHandler.onClose(e)},t.HASH_LINE_PATTERN=/#(\d*)(:(\d*))?$/,t.COLON_LINE_PATTERN=/:(\d*)(:(\d*))?$/,t.SYMBOL_SEARCH_INITIAL_TIMEOUT=500,t.SYMBOL_SEARCH_SUBSEQUENT_TIMEOUT=100,t.SEARCH_DELAY=100,t=__decorate([__param(0,m.IMessageService),__param(1,h.IInstantiationService)],t)}(u.QuickOpenHandler);t.OpenAnythingHandler=f});